<?php
defined('BASEPATH') OR exit('No direct script access allowed');
class Dashboard extends CI_Controller{
  public function __construct()
  {
    parent::__construct();
    $this->load->library('upload');
  }
  public function index()
  {
    if (empty($this->session->userdata('loggedInSU'))) {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Access Denied!');
      $this->session->set_flashdata('msg', 'You need to signed in to access dashboard!');
      return redirect(base_url('login.php'));
    }
    if ($this->crud->getCount('insurer', 'id', @$this->session->userdata('iid')) == 0) 
    {
      $iid = $this->crud->save('insurer', ['insurer_name'=>'raw'], true);
      $this->session->set_userdata('iid',$iid);
      $this->crud->update('insurer', 'id', $iid, ['insurer_name'=>$iid]);
    }
    $config['seoTitle'] = 'Dashboard | Instly Quote';
    $config['seoDesc'] = 'Dashboard | Instly Quote';
    $config['seoKey'] = 'Dashboard | Instly Quote';
    $this->load->view('theme/includes/login-sidebar', $config);
    $this->load->view('theme/dashbord');
    $this->load->view('theme/includes/login-footer');
  }
  public function createInsurer()
  {
    if (empty($this->session->userdata('loggedInSU'))) {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Access Denied!');
      $this->session->set_flashdata('msg', 'You need to signed in to access dashboard!');
      return redirect(base_url('login.php'));
    }
    $config['seoTitle'] = 'Create New Insurer | Instly Quote';
    $config['seoDesc'] = 'Create New Insurer | Instly Quote';
    $config['seoKey'] = 'Create New Insurer | Instly Quote';
    $this->load->view('theme/includes/login-sidebar', $config);
    $this->load->view('theme/dashbord');
    $this->load->view('theme/includes/login-footer');
  }
  // public function add()
  // {
  //   debug($_POST);
  //   debug($_SESSION);
  //   debug($_FILES, true);
  // }
  public function create() {
    $iid = $this->session->userdata('iid');
    // Initialize variables
    $inputArray = array(
      'deductible_file' => $_FILES['deductible_file'] ?? null,
      'deductible_name' => $this->input->post('deductible_name') ?? null,
      'deductible_rate_amount' => $this->input->post('deductible_rate_amount') ?? null,
      'deductible_rate' => $this->input->post('deductible_rate') ?? null
    );
    $deductCardArray = array();
    if (!empty($inputArray['deductible_file']['name'])) {
      foreach ($inputArray['deductible_file']['name'] as $index => $fileNames) {
        foreach ($fileNames as $innerIndex => $fileName) {
          $deductCardArray[$index]['deductible_file'] = array(
            'name' => $fileName,
            'type' => $inputArray['deductible_file']['type'][$index][$innerIndex],
            'tmp_name' => $inputArray['deductible_file']['tmp_name'][$index][$innerIndex],
            'error' => $inputArray['deductible_file']['error'][$index][$innerIndex],
            'size' => $inputArray['deductible_file']['size'][$index][$innerIndex]
          );
          $deductCardArray[$index]['deductible_name'] = $inputArray['deductible_name'][$index][$innerIndex];
          $deductCardArray[$index]['deductible_rate_arr'] = array();
          foreach ($inputArray['deductible_rate_amount'][$index] as $rateIndex => $rateAmount) {
            $deductCardArray[$index]['deductible_rate_arr'][] = array(
              'deductible_rate_amount' => $rateAmount,
              'deductible_rate' => $inputArray['deductible_rate'][$index][$rateIndex] ?? null // Using posted rate
            );
          }
        }
      }
    }
    // Load the upload library
    $this->load->library('upload');
    // Upload profile photo
    $profile_photo_path = $this->handle_file_upload('profile_photo', 'cdn/profile-photo/', 'gif|jpg|png|jpeg');
    // Upload application form
    $application_form_path = $this->handle_file_upload('application_form', 'cdn/application-form/', 'csv|pdf');
    // Upload company brochure
    $company_broacher_path = $this->handle_file_upload('company_broacher', 'cdn/company-broacher/', 'csv|pdf');
    // Prepare insurer data
    $mainData = array(
      'insurer_logo' => $profile_photo_path,
      'plans_subscriptions' => $this->input->post('plans_subscriptions'),
      'insurer_name' => $this->input->post('insurer_name'),
      'currency' => $this->input->post('currency'),
      'website' => $this->input->post('website'),
      'contact_number' => $this->input->post('mobile'),
      'email' => $this->input->post('email'),
      'application_form' => $application_form_path,
      'company_broacher' => $company_broacher_path
    );
    $this->crud->update('insurer', 'id', $iid, $mainData);
    // Process deductible files
    foreach ($deductCardArray as $key => $value) {
      // Set the file upload details
      $_FILES['myfile'] = $value['deductible_file'];
      $deductible_file_path = $this->handle_file_upload('myfile', 'cdn/deductible-file/', 'csv');
      if ($deductible_file_path) {
        $deductible_file = array(
          'path' => $deductible_file_path,
          'iid' => $iid,
          'deductible_name' => $value['deductible_name']
        );
        $deductible_file_id = $this->crud->save('deductible_files', $deductible_file, true);
        if ($deductible_file_id) {
          // Import CSV data
          $this->import_csv_to_db($deductible_file['path'], $deductible_file_id, $iid);
          // Save deductible rates
          foreach ($value['deductible_rate_arr'] as $deductible_rate) {
            $deductibleRateDataToSave = array_merge($deductible_rate, array(
              'deductible_files_id' => $deductible_file_id,
              'iid' => $iid,
              'added' => date('Y-m-d H:i:s')
            ));
            $this->crud->save('deductible_rates', $deductibleRateDataToSave, false);
          }
        }
      }
    }
    $this->session->unset_userdata('iid');
    $this->session->set_flashdata('type', 'success');
    $this->session->set_flashdata('title', 'Data Saved!');
    $this->session->set_flashdata('msg', 'The insurer data has been saved successfully.');
    return redirect(base_url('dashboard.php'));
  }
  public function editInsurer($id = null)
  {
    if (empty($this->session->userdata('loggedInSU'))) {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Access Denied!');
      $this->session->set_flashdata('msg', 'You need to signed in to access dashboard!');
      return redirect(base_url('login.php'));
    }else {
      if (!empty($id) && $this->crud->getCount('insurer', 'id', hashed($id,'d')) == 0) {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Insurer Not Found!');
        $this->session->set_flashdata('msg', 'Unable to find the insurer!');
        return redirect(base_url('dashboard.php'));
      }
      $config['insurerData'] = $this->crud->getDataSingle('insurer', hashed($id,'d'), 'id', null);
      $config['seoTitle'] = 'Edit Insurer Details | Instly Quote';
      $config['seoDesc'] = 'Edit Insurer Details | Instly Quote';
      $config['seoKey'] = 'Edit Insurer Details | Instly Quote';
      $this->load->view('theme/includes/login-sidebar', $config);
      $this->load->view('theme/edit-insurer');
      $this->load->view('theme/includes/login-footer');
    }
  }
  public function updateInsureDetails() {
    if ($this->input->is_ajax_request()) {
      $this->load->library('form_validation');
      $this->form_validation->set_rules('insurer_name', 'Insurer Name', 'required');
      $this->form_validation->set_rules('email', 'Email', 'required|valid_email');
      // Add more validation rules as needed
      if ($this->form_validation->run() === FALSE) {
        echo json_encode(['status' => 'error', 'message' => validation_errors()]);
        return;
      }
      // Process form data and file uploads
      $data = [
        'insurer_name' => $this->input->post('insurer_name'),
        'email' => $this->input->post('email'),
        'contact_number' => $this->input->post('mobile'),
        'website' => $this->input->post('website'),
        'currency' => $this->input->post('currency'),
        'plans_subscriptions' => $this->input->post('plans_subscriptions'),
        // Other fields
      ];
      if (!empty($_FILES['profile_photo']['name'])) {
        $file_path = $this->handle_file_upload('profile_photo', 'cdn/profile-photo/', 'jpg|png|jpeg|svg|gif|webp');
        if ($file_path) {
          $data['insurer_logo'] = $file_path;
        } else {
          echo json_encode(['status' => 'error', 'message' => 'File upload failed']);
          return;
        }
      }
      if (!empty($_FILES['application_form']['name'])) {
        $file_path = $this->handle_file_upload('application_form', 'cdn/application-form/', 'pdf|csv');
        if ($file_path) {
          $data['application_form'] = $file_path;
        } else {
          echo json_encode(['status' => 'error', 'message' => 'File upload failed']);
          return;
        }
      }
      if (!empty($_FILES['company_broacher']['name'])) {
        $file_path = $this->handle_file_upload('company_broacher', 'cdn/company-broacher/', 'pdf|csv');
        if ($file_path) {
          $data['company_broacher'] = $file_path;
        } else {
          echo json_encode(['status' => 'error', 'message' => 'File upload failed']);
          return;
        }
      }
      $iid = hashed($this->input->post('iid'), 'd'); // Get insurer ID
      $update = $this->crud->update_insurer($iid, $data);
      if ($update) {
        echo json_encode(['status' => 'success']);
      } else {
        echo json_encode(['status' => 'error', 'message' => 'Failed to update']);
      }
    } else {
      show_404();
    }
  }
  private function handle_file_upload($field_name, $upload_path, $allowed_types) {
    $config = array(
      'upload_path' => $upload_path,
      'allowed_types' => $allowed_types,
      'max_size' => 10000, // 10MB
      'encrypt_name' => TRUE
    );
    $this->upload->initialize($config);
    if ($this->upload->do_upload($field_name)) {
      $upload_data = $this->upload->data();
      return $upload_path . $upload_data['file_name'];
    } else {
      log_message('error', $this->upload->display_errors());
      return null;
    }
  }
  public function import_csv_to_db($filePath, $deductible_files_id, $iid) {
    $this->load->database();
    if (($handle = fopen($filePath, "r")) !== FALSE) {
      fgetcsv($handle);
      while (($row = fgetcsv($handle, 1000, ",")) !== FALSE) {
        $data = array(
          'age' => $row[0],
          'premium' => $row[1],
          'deductible_files_id' => $deductible_files_id,
          'iid' => $iid,
          'added' => date('Y-m-d H:i:s')
        );
        $this->db->insert('deductible_file_data', $data);
      }
      fclose($handle);
    } else {
      log_message('error', "Error opening the file at path: $filePath");
    }
  }
  public function deleteDeductable() {
    if ($this->input->server('REQUEST_METHOD') === 'POST') {
      $deductableID = $this->input->post('deductableID');
      $insurerID = $this->input->post('insurerID');
      // Get the deductible file details
      $deductible_files = $this->crud->getDeductibleFilesRow($insurerID, $deductableID);
      if (!$deductible_files) {
        echo 'error: No deductible files found';
        return;
      }
      // Delete records from dependent tables first
      $deductible_rates = $this->crud->getDeductibleRates($insurerID, $deductible_files->id);
      foreach ($deductible_rates as $rate) {
        $this->crud->delete('deductible_rates', 'id', $rate->id);
      }
      $deductible_file_data = $this->crud->getDeductibleFileAgeWiseDataAll($insurerID, $deductible_files->id);
      foreach ($deductible_file_data as $data) {
        $this->crud->delete('deductible_file_data', 'id', $data->id);
      }
      // Delete the file from the server
      if (!$this->crud->delete_file('./cdn/deductible-file/' . $deductible_files->path)) {
        echo 'error: File deletion failed';
        return;
      }
      // Finally, delete the deductible file record
      if (!$this->crud->delete('deductible_files', 'id', $deductible_files->id)) {
        echo 'error: Deductible file deletion failed';
        return;
      }
      echo 'success';
    } else {
      echo 'error: Invalid request method';
    }
  }
  public function saveDeductableData() {
    $iid = $this->input->post('iid');
    $deductible_name = $this->input->post('deductible_name');
    $deductible_rate_amount = $this->input->post('deductible_rate_amount');
    $deductible_rate = $this->input->post('deductible_rate');
    // Define upload path
    $upload_path = './cdn/deductible-file/';
    // Upload the CSV file using the handle_file_upload function
    $filePath = $this->handle_file_upload('deductible_file', $upload_path, 'csv');
    if ($filePath) {
      // Save data to "deductible_files" table
      $fileData = array(
        'iid' => $iid,
        'path' => basename($filePath), // Only save file name
        'deductible_name' => $deductible_name,
        'created' => date('Y-m-d H:i:s')
      );
      $deductible_file_id = $this->crud->saveDeductibleFile($fileData);
      // Save data to "deductible_rates" table
      foreach ($deductible_rate_amount as $key => $amount) {
        $rateData = array(
          'deductible_rate_amount' => $amount,
          'deductible_rate' => $deductible_rate[$key],
          'deductible_files_id' => $deductible_file_id,
          'iid' => $iid,
          'added' => date('Y-m-d H:i:s')
        );
        $this->crud->saveDeductibleRate($rateData);
      }
      // Save CSV data to "deductible_file_data" table
      $this->import_csv_to_db($filePath, $deductible_file_id, $iid);
      echo json_encode(['status' => 'success']);
    } else {
      echo json_encode(['status' => 'error', 'message' => 'File upload failed.']);
    }
  }
  public function updateField()
  {
    if ($this->input->server('REQUEST_METHOD') === 'POST') {
      // debug($this->input->post(),true);
      $type = $this->input->post('type') ?? null;
      $id = $this->input->post('id') ?? null;
      $value = $this->input->post('value') ?? null;
      // debug($this->crud->update('deductible_rates', 'id', $id, ['deductible_rate_amount'=>$value]),true);
      if ($type == 'deductible_rate_amount') {
        if ($this->crud->update('deductible_rates', 'id', $id, ['deductible_rate_amount'=>$value])) {
          echo 'success';
        } else {
          echo 'error';
        }
        
      }
      elseif ($type == 'deductible_rate') {
        if ($this->crud->update('deductible_rates', 'id', $id, ['deductible_rate'=>$value])) {
          echo 'success';
        } else {
          echo 'error';
        }
        
      }
      else {
        echo 'error';
      }
    } else {
      echo 'error';
    }
  }
  public function deleteField()
  {
    if ($this->input->server('REQUEST_METHOD') === 'POST') {
      $id = $this->input->post('id') ?? null;
      // debug($this->crud->update('deductible_rates', 'id', $id, ['deductible_rate_amount'=>$value]),true);
      if ($this->crud->delete('deductible_rates', 'id', $id)) {
        echo 'success';
      } else {
        echo 'error';
      }
    } else {
      echo 'error';
    }
  }
  public function deleteInsurerBulk()
  {
    if ($this->input->server('REQUEST_METHOD') === 'POST') {
      $insurerID = $this->input->post('insurerID');
      if (!empty($insurerID)) {
        foreach ($insurerID as $id) {
          @$this->crud->delete('insurer', 'id', $id);
        }
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Insurer Deleted!');
        $this->session->set_flashdata('msg', 'The selected insurer has been deleted successfully.');
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occured!');
        $this->session->set_flashdata('msg', 'Unable to process your request');
      }
      return redirect(base_url('dashboard.php'));
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('dashboard.php'));
    }
  }
  public function export() {
    // Retrieve insurer data
    $insurers = $this->crud->get_all_insurers();
    
    // Load the URL helper to use base_url()
    $this->load->helper('url');
    
    // Define the CSV file name
    $filename = 'insurers-exported-sheet-' . date('Y-m-d') . '.csv';
    
    // Set headers for the CSV download
    header('Content-Type: text/csv; charset=utf-8');
    header('Content-Disposition: attachment; filename="' . $filename . '";');
    
    // Open the output stream
    $output = fopen('php://output', 'w');
    
    // Insert column headers
    fputcsv($output, array(
      'ID', 
      'Insurer Logo', 
      'Plans Subscriptions', 
      'Insurer Name', 
      'Currency', 
      'Website', 
      'Contact Number', 
      'Email', 
      'Application Form', 
      'Company Brochure', 
      'Created'
    ));
    
    // Insert rows
    foreach ($insurers as $insurer) {
      if (!ctype_digit($insurer['insurer_name'])) {
        if (!empty($insurer['insurer_name'])) {
          $row = array(
            $insurer['id'],
            base_url($insurer['insurer_logo']),
            $insurer['plans_subscriptions'],
            $insurer['insurer_name'],
            $insurer['currency'],
            $insurer['website'],
            $insurer['contact_number'],
            $insurer['email'],
            base_url($insurer['application_form']),
            base_url($insurer['company_broacher']),
            $insurer['created']
          );
          fputcsv($output, $row);
        }
      }
    }
    
    // Close the output stream
    fclose($output);
    exit;
  }
  
}
?>