<?php
defined('BASEPATH') OR exit('No direct script access allowed');
class Home extends CI_Controller{
  public function __construct()
  {
    parent::__construct();
    // $this->load->library('email');
    // $config = array(
    //   'protocol'  => 'smtp', // or 'mail'
    //   'smtp_host' => 'mail.domain.in',
    //   'smtp_port' => 465, // or 25
    //   'smtp_user' => 'email',
    //   'smtp_pass' => 'password',
    //   'mailtype'  => 'html',
    //   'charset'   => 'utf-8'
    // );
    // $this->email->initialize($config);
    // $this->email->from('no-reply@email.com', 'Domain Name');
  }
  public function index()
  {
    $config['seoTitle'] = 'Instly Quote';
    $config['seoDesc'] = 'Instly Quote';
    $config['seoKey'] = 'Instly Quote';
    $this->load->view('theme/includes/header', $config);
    $this->load->view('theme/index');
    $this->load->view('theme/includes/footer');
  }
  public function privacyPolicy()
  {
    $config['seoTitle'] = 'Instly Quote';
    $config['seoDesc'] = 'Instly Quote';
    $config['seoKey'] = 'Instly Quote';
    $this->load->view('theme/includes/header', $config);
    $this->load->view('theme/privacy-policy');
    $this->load->view('theme/includes/footer');
  }
  public function TermsofService()
  {
    $config['seoTitle'] = 'Instly Quote';
    $config['seoDesc'] = 'Instly Quote';
    $config['seoKey'] = 'Instly Quote';
    $this->load->view('theme/includes/header', $config);
    $this->load->view('theme/terms-of-service');
    $this->load->view('theme/includes/footer');
  }
  public function quoteForm()
  {
    $config['seoTitle'] = 'Instly Quote';
    $config['seoDesc'] = 'Instly Quote';
    $config['seoKey'] = 'Instly Quote';
    $this->load->view('theme/includes/header', $config);
    $this->load->view('theme/quote-form');
    $this->load->view('theme/includes/footer');
  }
  public function fetch_country()
  {
    if ($this->input->server('REQUEST_METHOD') === 'POST') {
      if(isset($_POST['continent'])) {
        $continent = $_POST['continent'];
        // Fetch the country list based on the selected continent
        $countries = $this->crud->getCountriesByContinent($continent); // Replace with your actual method
        // Return JSON response
        echo json_encode($countries);
      }
    }
  }
  public function processForm()
  {
    if ($this->input->server('REQUEST_METHOD') === 'POST') {
      $data['fullname'] = $this->input->post('fullname') ?? null;
      $data['continent'] = $this->input->post('continent') ?? null;
      $data['nationality'] = $this->input->post('nationality') ?? null;
      $data['covered_person'] = $this->input->post('covered_person') ?? null;
      if (!empty($this->input->post('covered_type'))) {
        if (is_array($this->input->post('covered_type'))) {
          $data['covered_type'] = implode(',', $this->input->post('covered_type'));
        } else {
          $data['covered_type'] = $this->input->post('covered_type');
        }
      } else {
        $data['covered_type'] = null;
      }
      $data['my_age'] = $this->input->post('my_age') ?? null;
      $data['betterhalf_age'] = $this->input->post('betterhalf_age') ?? null;
      if ($data['my_age'] > $data['betterhalf_age']) {
        $data['maxage'] = @$data['my_age'];
      } else {
        $data['maxage'] = @$data['betterhalf_age'];
      }
      if (!empty($this->input->post('child_age'))) {
        if (is_array($this->input->post('child_age'))) {
          $data['child_age'] = implode(',', $this->input->post('child_age'));
        } else {
          $data['child_age'] = $this->input->post('child_age');
        }
      } else {
        $data['child_age'] = null;
      }
      $data['created'] = date('Y-m-d H:i:s');
      if ($id=$this->crud->save('requests', $data, true)) {
        $savedData = $this->crud->getDataSingle('requests', $id, 'id', null);
        $this->session->set_userdata('savedData', $savedData);
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Choose policy!');
        $this->session->set_flashdata('msg', 'Now choose the policy.');
        return redirect(base_url('insurance-listing.php'));
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occured!');
        $this->session->set_flashdata('msg', 'Unable to update process the request!');
        return redirect(base_url('quote-form.php'));
      }
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('quote-form.php'));
    }
  }
  public function getPolicyDataApi($id=null)
  {
    if (!empty($id) && $this->crud->getCount('policies', 'id', hashed($id,'d')) > 0) {
      $policyDetails = $this->crud->getDataSingle('policies', hashed($id,'d'), 'id', null);
      if (!empty($policyDetails)) {
        $insurerDetails = $this->crud->getDataSingle('insurer', $policyDetails->insurer_id, 'id', null);
        if ($insurerDetails->currency == 'USD') {
          $selectedCurrency = 'USD';
          $selectedCurrencyCode = '$';
        }
        if ($insurerDetails->currency == 'Thai') {
          $selectedCurrency = 'Thai';
          $selectedCurrencyCode = '฿';
        }
        $data['facilities'] = cleanVal($policyDetails->facilities) ?? null;;
        $data['pid'] = cleanVal($policyDetails->id) ?? null;;
        $data['insurer_logo'] = base_url($insurerDetails->insurer_logo ?? null);
        $data['insurer_name'] = $insurerDetails->insurer_name ?? null;
        $data['policy_name'] = cleanVal($policyDetails->policy_name) ?? null;
        $data['annual_limit'] = cleanVal($policyDetails->annual_limit) ?? null;
        $data['inpatient_info_room_board'] = cleanVal($policyDetails->inpatient_info_room_board) ?? null;
        $data['inpatient_info_cancer'] = cleanVal($policyDetails->inpatient_info_cancer) ?? null;
        $data['inpatient_info_hospitalization_expenses'] = cleanVal($policyDetails->inpatient_info_hospitalization_expenses) ?? null;
        $data['inpatient_info_outpatient_surgery'] = cleanVal($policyDetails->inpatient_info_outpatient_surgery) ?? null;
        $data['inpatient_info_mri_ct_pet_scans'] = cleanVal($policyDetails->inpatient_info_mri_ct_pet_scans) ?? null;
        $data['inpatient_info_pre_post_hospitalization'] = cleanVal($policyDetails->inpatient_info_pre_post_hospitalization) ?? null;
        $data['inpatient_info_psychiatric_care'] = cleanVal($policyDetails->inpatient_info_psychiatric_care) ?? null;
        $data['inpatient_info_emergency_evacuation'] = cleanVal($policyDetails->inpatient_info_emergency_evacuation) ?? null;
        $data['outpatient_info_annual_limit'] = cleanVal($policyDetails->outpatient_info_annual_limit) ?? null;
        $data['outpatient_info_doctors_fee'] = cleanVal($policyDetails->outpatient_info_doctors_fee) ?? null;
        $data['outpatient_info_routine_tests'] = cleanVal($policyDetails->outpatient_info_routine_tests) ?? null;
        $data['outpatient_info_prescribed_drugs'] = cleanVal($policyDetails->outpatient_info_prescribed_drugs) ?? null;
        $data['outpatient_info_physiotherapy'] = cleanVal($policyDetails->outpatient_info_physiotherapy) ?? null;
        $data['outpatient_info_chiropractor'] = cleanVal($policyDetails->outpatient_info_chiropractor) ?? null;
        $data['outpatient_info_psychiatric_care'] = cleanVal($policyDetails->outpatient_info_psychiatric_care) ?? null;
        $data['outpatient_info_annual_health_checks'] = cleanVal($policyDetails->outpatient_info_annual_health_checks) ?? null;
        $data['outpatient_info_vaccines'] = cleanVal($policyDetails->outpatient_info_vaccines) ?? null;
        $data['dental_info_annual_limit'] = cleanVal($policyDetails->dental_info_annual_limit) ?? null;
        $data['dental_info_major_dental'] = cleanVal($policyDetails->dental_info_major_dental) ?? null;
        $data['dental_info_minor_dental'] = cleanVal($policyDetails->dental_info_minor_dental) ?? null;
        $data['dental_info_vision'] = cleanVal($policyDetails->dental_info_vision) ?? null;
        $data['maternity_annual_limit'] = cleanVal($policyDetails->maternity_annual_limit) ?? null;
        $data['maternity_routine_delivery'] = cleanVal($policyDetails->maternity_routine_delivery) ?? null;
        $data['maternity_outpatient_maternity'] = cleanVal($policyDetails->maternity_outpatient_maternity) ?? null;
        $data['maternity_maternity_complication'] = cleanVal($policyDetails->maternity_maternity_complication) ?? null;
        $decoded_array = array_map('html_entity_decode', $data);
        echo json_encode($decoded_array);
      } else {
        echo 'error';
      }
    } else {
      echo 'error';
    }
  }
  public function getAnualPremiumAPI()
  {
    if ($this->input->server('REQUEST_METHOD') === 'POST') {
      if (!empty($this->input->post('data'))) {
        $data = $this->input->post('data');
        $dataArr = explode('-',$data);
        if (is_array($dataArr)) {
          if (count($dataArr) == 3) {
            $premium = (int)hashed($dataArr[0],'d') ?? (int)'0';
            echo $premium;
          } else {
            $deductible_rates_id = hashed($dataArr[0],'d') ?? (int)'0';
            $maxage = hashed($dataArr[1],'d') ?? (int)'0';
            $deductible_rates = $this->crud->getDataSingle('deductible_rates', $deductible_rates_id, 'id', null);
            $getDeductibleFileAgeWiseData = $this->crud->getDeductibleFileAgeWiseData($deductible_rates->iid, $deductible_rates->deductible_files_id, $maxage);
            $rate = $deductible_rates->deductible_rate;
            $defaultPremium = $getDeductibleFileAgeWiseData->premium;
            $percentageValue = ($defaultPremium * $rate) / 100;
            $updatedPremium = $defaultPremium - $percentageValue;
            echo round($updatedPremium);
          }
        } else {
          echo 'error';
        }
      } else {
        echo 'error';
      }
    } else {
      echo 'error';
    }
  }
  public function insuranceListing()
  {
    if ($this->input->server('REQUEST_METHOD') === 'POST') {
      $data['name'] = $this->input->post('name') ?? null;
      $data['email'] = $this->input->post('email') ?? null;
      $data['phone'] = $this->input->post('phone') ?? null;
      $data['pid'] = hashed($this->input->post('pid'), 'd') ?? null;
      $data['policy_name'] = hashed($this->input->post('policy_name'), 'd') ?? null;
      $data['insurer_name'] = hashed($this->input->post('insurer_name'), 'd') ?? null;
      $data['rid'] = hashed($this->input->post('rid'), 'd') ?? null;
      $data['added'] = date('Y-m-d H:i:s');
      if ($this->crud->save('requests_emails', $data, false)) {
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Email Sent!');
        $this->session->set_flashdata('msg', 'We\'ll coonect soon!');
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occured!');
        $this->session->set_flashdata('msg', 'Unable to process your request!');
      }
      return redirect(base_url('insurance-listing'));
    } else {
      $config['seoTitle'] = 'Insurance Listing - Instly Quote';
      $config['seoDesc'] = 'Insurance Listing - Instly Quote';
      $config['seoKey'] = 'Insurance Listing - Instly Quote';
      $this->load->view('theme/includes/header', $config);
      $this->load->view('theme/insurance-listing');
      $this->load->view('theme/includes/footer');
    }
  }
  public function test()
  {
    $message = '<!doctype html>
    <html lang="en-US">
    <head>
    <meta content="text/html; charset=utf-8" http-equiv="Content-Type" />
    <title>Reset Password Email Template</title>
    <meta name="description" content="Reset Password Email Template.">
    <style type="text/css">
    a:hover {text-decoration: underline !important;}
    </style>
    </head>
    <body marginheight="0" topmargin="0" marginwidth="0" style="margin: 0px; background-color: #f2f3f8;" leftmargin="0">
    <!--100% body table-->
    <table cellspacing="0" border="0" cellpadding="0" width="100%" bgcolor="#f2f3f8" style="@import url(https://fonts.googleapis.com/css?family=Rubik:300,400,500,700|Open+Sans:300,400,600,700); font-family: \'Open Sans\', sans-serif;">
    <tr>
    <td>
    <table style="background-color: #f2f3f8; max-width:670px;  margin:0 auto;" width="100%" border="0"
    align="center" cellpadding="0" cellspacing="0">
    <tr>
    <td style="height:80px;">&nbsp;</td>
    </tr>
    <tr>
    <td style="text-align:center;">
    <a href="'.base_url().'" title="logo" target="_blank">
    <img width="60%" src="'.base_url($this->crud->getSetting('websiteLogo')).'" title="'.$this->crud->getSetting('websiteName').'" alt="'.$this->crud->getSetting('websiteName').'">
    </a>
    </td>
    </tr>
    <tr>
    <td style="height:20px;">&nbsp;</td>
    </tr>
    <tr>
    <td>
    <table width="95%" border="0" align="center" cellpadding="0" cellspacing="0"
    style="max-width:670px;background:#fff; border-radius:3px; text-align:center;-webkit-box-shadow:0 6px 18px 0 rgba(0,0,0,.06);-moz-box-shadow:0 6px 18px 0 rgba(0,0,0,.06);box-shadow:0 6px 18px 0 rgba(0,0,0,.06);">
    <tr>
    <td style="height:40px;">&nbsp;</td>
    </tr>
    <tr>
    <td style="padding:0 35px;">
    <h1 style="color:#1e1e2d; font-weight:500; margin:0;font-size:32px;font-family:\'Rubik\',sans-serif;">You have
    requested to reset your password</h1>
    <span
    style="display:inline-block; vertical-align:middle; margin:29px 0 26px; border-bottom:1px solid #cecece; width:100px;"></span>
    <p style="color:#455056; font-size:15px;line-height:24px; margin:0;">
    We cannot simply send you your old password. A unique link to reset your
    password has been generated for you. To reset your password, click the
    following link and follow the instructions.
    </p>
    <a href="javascript:void(0);"
    style="background:#20e277;text-decoration:none !important; font-weight:500; margin-top:35px; color:#fff;text-transform:uppercase; font-size:14px;padding:10px 24px;display:inline-block;border-radius:50px;">Reset
    Password</a>
    </td>
    </tr>
    <tr>
    <td style="height:40px;">&nbsp;</td>
    </tr>
    </table>
    </td>
    <tr>
    <td style="height:20px;">&nbsp;</td>
    </tr>
    <tr>
    <td style="text-align:center;">
    <p style="font-size:14px; color:rgba(69, 80, 86, 0.7411764705882353); line-height:18px; margin:0 0 0;">&copy; <strong>www.psco.in</strong></p>
    </td>
    </tr>
    <tr>
    <td style="height:80px;">&nbsp;</td>
    </tr>
    </table>
    </td>
    </tr>
    </table>
    <!--/100% body table-->
    </body>
    </html>';
    // echo $message;
    $this->email->to('pawan.webmaster@gmail.com');
    $this->email->subject('Reset your password');
    $this->email->message($message);
    $this->email->send();
  }
  public function forgetPassword()
  {
    $config['seoTitle'] = 'Forget Password | myCMS v2.1';
    $config['seoDesc'] = 'Forget Password | myCMS v2.1';
    $config['seoKey'] = 'Forget Password | myCMS v2.1, Secure Access';
    $this->load->view('public/common/header', $config);
    $this->load->view('public/forget-password');
    $this->load->view('public/common/footer');
  }
  public function forgetPasswordProcess()
  {
    if ($this->input->server('REQUEST_METHOD') === 'POST') {
      $email = cleanVal($this->input->post('email'));
      if ($this->crud->getCount('su', 'email', $email) > 0) {
        $userDetails = $this->crud->getDataSingle('su', $email, 'email', null);
        $resetURL = base_url('authenticate-token/'.hashed($userDetails->token));
        $message = '<!doctype html>
        <html lang="en-US">
        <head>
        <meta content="text/html; charset=utf-8" http-equiv="Content-Type" />
        <title>Reset Password Email Template</title>
        <meta name="description" content="Reset Password Email Template.">
        <style type="text/css">
        a:hover {text-decoration: underline !important;}
        </style>
        </head>
        <body marginheight="0" topmargin="0" marginwidth="0" style="margin: 0px; background-color: #f2f3f8;" leftmargin="0">
        <!--100% body table-->
        <table cellspacing="0" border="0" cellpadding="0" width="100%" bgcolor="#f2f3f8" style="@import url(https://fonts.googleapis.com/css?family=Rubik:300,400,500,700|Open+Sans:300,400,600,700); font-family: \'Open Sans\', sans-serif;">
        <tr>
        <td>
        <table style="background-color: #f2f3f8; max-width:670px;  margin:0 auto;" width="100%" border="0"
        align="center" cellpadding="0" cellspacing="0">
        <tr>
        <td style="height:80px;">&nbsp;</td>
        </tr>
        <tr>
        <td style="text-align:center;">
        <a href="'.base_url().'" title="logo" target="_blank">
        <img width="60%" src="'.base_url($this->crud->getSetting('websiteLogo')).'" title="'.$this->crud->getSetting('websiteName').'" alt="'.$this->crud->getSetting('websiteName').'">
        </a>
        </td>
        </tr>
        <tr>
        <td style="height:20px;">&nbsp;</td>
        </tr>
        <tr>
        <td>
        <table width="95%" border="0" align="center" cellpadding="0" cellspacing="0"
        style="max-width:670px;background:#fff; border-radius:3px; text-align:center;-webkit-box-shadow:0 6px 18px 0 rgba(0,0,0,.06);-moz-box-shadow:0 6px 18px 0 rgba(0,0,0,.06);box-shadow:0 6px 18px 0 rgba(0,0,0,.06);">
        <tr>
        <td style="height:40px;">&nbsp;</td>
        </tr>
        <tr>
        <td style="padding:0 35px;">
        <h1 style="color:#1e1e2d; font-weight:500; margin:0;font-size:32px;font-family:\'Rubik\',sans-serif;">You have
        requested to reset your password</h1>
        <span
        style="display:inline-block; vertical-align:middle; margin:29px 0 26px; border-bottom:1px solid #cecece; width:100px;"></span>
        <p style="color:#455056; font-size:15px;line-height:24px; margin:0;">
        We cannot simply send you your old password. A unique link to reset your
        password has been generated for you. To reset your password, click the
        following link and follow the instructions.
        </p>
        <a href="'.$resetURL.'"
        style="background:#20e277;text-decoration:none !important; font-weight:500; margin-top:35px; color:#fff;text-transform:uppercase; font-size:14px;padding:10px 24px;display:inline-block;border-radius:50px;">Reset Password</a>
        </td>
        </tr>
        <tr>
        <td style="height:40px;">&nbsp;</td>
        </tr>
        </table>
        </td>
        <tr>
        <td style="height:20px;">&nbsp;</td>
        </tr>
        <tr>
        <td style="text-align:center;">
        <p style="font-size:14px; color:rgba(69, 80, 86, 0.7411764705882353); line-height:18px; margin:0 0 0;">&copy; <strong>www.psco.in</strong></p>
        </td>
        </tr>
        <tr>
        <td style="height:80px;">&nbsp;</td>
        </tr>
        </table>
        </td>
        </tr>
        </table>
        <!--/100% body table-->
        </body>
        </html>';
        // echo $message;
        $this->email->to($userDetails->email);
        $this->email->subject('Reset your password');
        $this->email->message($message);
        if ($this->email->send()) {
          $this->session->set_flashdata('type', 'success');
          $this->session->set_flashdata('title', 'Check Your Email!');
          $this->session->set_flashdata('msg', 'We had sent you password reset link. Please confirm and reset your password.');
          $this->session->set_flashdata('requestSent', 'sent');
        } else {
          $this->session->set_flashdata('type', 'error');
          $this->session->set_flashdata('title', 'Unable to process!');
          $this->session->set_flashdata('msg', 'We are unable to process your request!');
        }
        return redirect(base_url('admin-forget-password.php'));
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Invalid Email Account!');
        $this->session->set_flashdata('msg', 'Please enter registered email account!');
        return redirect(base_url('admin-forget-password.php'));
      }
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('admin-forget-password.php'));
    }
  }
  public function authenticateToken($token = null)
  {
    if (!empty($token)) {
      if ($this->crud->getCount('su', 'token', hashed($token,'d')) > 0) {
        $config['seoTitle'] = 'Update Password!';
        $config['seoDesc'] = 'Update Password.';
        $config['seoKey'] = 'Update Password, Secure Access';
        $config['userDetails'] = $this->crud->getDataSingle('su', hashed($token,'d'), 'token', null);
        $this->crud->update('su', 'email', $config['userDetails']->email, ['token'=>hashed(time())]);
        $this->load->view('public/common/header', $config);
        $this->load->view('public/authenticate-token');
        $this->load->view('public/common/footer');
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Link Expired/Invalid!');
        $this->session->set_flashdata('msg', 'The reset password has been expired or invalid!');
        return redirect(base_url('admin-forget-password.php'));
      }
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('admin-forget-password.php'));
    }
  }
  public function processNewPassword()
  {
    if ($this->input->server('REQUEST_METHOD') === 'POST') {
      $id = hashed(hashed(cleanVal($this->input->post('pnpid')),'d'),'d');
      $data['password'] = cleanVal(hashed($this->input->post('password')));
      if ($this->crud->update('su', 'id', $id, $data)) {
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Password Changed!');
        $this->session->set_flashdata('msg', 'The password has been updated successfully.');
        return redirect(base_url('su-login.php'));
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occured!');
        $this->session->set_flashdata('msg', 'Unable to process your request!');
        return redirect(base_url('admin-forget-password.php'));
      }
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('su-login.php'));
    }
  }
  public function login()
  {
    if ($this->session->userdata('loggedInSU')) {
      $this->session->set_flashdata('type', 'success');
      $this->session->set_flashdata('title', 'Already Signed In!');
      $this->session->set_flashdata('msg', 'Dear Admin, Yo\'re already signed in!');
      return redirect(base_url('admin.php'));
    }
    $config['seoTitle'] = 'Login To Access!';
    $config['seoDesc'] = 'Secure login area.';
    $config['seoKey'] = 'Login, Secure Access';
    $this->load->view('public/common/header', $config);
    $this->load->view('public/admin-login');
    $this->load->view('public/common/footer');
  }
  public function authenticateSuperUser()
  {
    if ($this->input->server('REQUEST_METHOD') === 'POST') {
      $un = hashed(cleanVal($this->input->post('username')));
      $pw = hashed(cleanVal($this->input->post('password')));
      $rb = $this->input->post('remember');
      if (!empty($rb) && $rb === 'remember') {
        $rmb = true;
      } else {
        $rmb = false;
      }
      // debug($pw);
      // debug($un,true);
      if ($this->crud->verify_user($un,$pw,$rmb)) {
        $this->session->set_userdata('loggedInSU',$un);
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Authentication Successfull!');
        $this->session->set_flashdata('msg', 'Welcome Admin');
        return redirect(base_url('admin.php'));
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Authentication Failed!');
        $this->session->set_flashdata('msg', 'Unable to authenticate, Please check your credentials!');
        return redirect(base_url('su-login.php'));
      }      
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('su-login.php'));
    }
  }
  public function clearRememberMe()
  {
    if (delete_cookie('rm', 'oneandallservices.in', '/', 'crm_')) {
      $this->session->set_flashdata('type', 'success');
      $this->session->set_flashdata('title', 'Remember Me - Cleared!');
      $this->session->set_flashdata('msg', 'Cleared the remeber option successfully.');
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error Occured!');
      $this->session->set_flashdata('msg', 'Unable to process your request!');
    }
    return redirect(base_url('su-login.php'));
  }
}
?>