<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Login extends CI_Controller{
  public function index()
  {
    if (!empty($this->session->userdata('loggedInSU'))) {
      $this->session->set_flashdata('type', 'warning');
      $this->session->set_flashdata('title', 'Already Authenticated!');
      $this->session->set_flashdata('msg', 'You are already signed in!');
      return redirect(base_url('dashboard.php'));
    }
    $config['seoTitle'] = 'Login | Instly Quote';
    $config['seoDesc'] = 'Login | Instly Quote';
    $config['seoKey'] = 'Login | Instly Quote';
    $this->load->view('theme/includes/header', $config);
    $this->load->view('theme/login');
    $this->load->view('theme/includes/footer');
  }
  public function authenticateSuperUser()
  {
    if ($this->input->server('REQUEST_METHOD') === 'POST') {
      $un = hashed(cleanVal($this->input->post('username')));
      $pw = hashed(cleanVal($this->input->post('password')));
      $rb = $this->input->post('remember');
      if (!empty($rb) && $rb === 'remember') {
        $rmb = true;
      } else {
        $rmb = false;
      }
      // debug($pw);
      // debug($un,true);
      if ($this->crud->verify_user($un,$pw,$rmb)) {
        $this->session->set_userdata('loggedInSU',$un);
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Authentication Successfull!');
        $this->session->set_flashdata('msg', 'Welcome Admin');
        return redirect(base_url('dashboard.php'));
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Authentication Failed!');
        $this->session->set_flashdata('msg', 'Unable to authenticate, Please check your credentials!');
        return redirect(base_url('login.php'));
      }      
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('login.php'));
    }
  }
  public function clearRememberMe()
  {
    if (delete_cookie('rm', 'oneandallservices.in', '/', 'crm_')) {
      $this->session->set_flashdata('type', 'success');
      $this->session->set_flashdata('title', 'Remember Me - Cleared!');
      $this->session->set_flashdata('msg', 'Cleared the remeber option successfully.');
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error Occured!');
      $this->session->set_flashdata('msg', 'Unable to process your request!');
    }
    return redirect(base_url('login.php'));
  }
}
?>