<?php
defined('BASEPATH') OR exit('No direct script access allowed');
class Messages extends CI_Controller{
  public function index()
  {
    if (empty($this->session->userdata('loggedInSU'))) {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Access Denied!');
      $this->session->set_flashdata('msg', 'You need to signed in to access dashboard!');
      return redirect(base_url('login.php'));
    }
    $config['seoTitle'] = 'Messages Dashboard | Instly Quote';
    $config['seoDesc'] = 'Messages Dashboard | Instly Quote';
    $config['seoKey'] = 'Messages Dashboard | Instly Quote';
    $this->load->view('theme/includes/login-sidebar', $config);
    $this->load->view('theme/messages-dashbord');
    $this->load->view('theme/includes/login-footer');
  }
  public function delete($id=null)
  {
    // debug($this->crud->getCount('requests', 'id', hashed($id,'d')),true);
    if (!empty($id) && $this->crud->getCount('requests', 'id', hashed($id,'d')) > 0) {
      if ($this->crud->delete('requests', 'id', hashed($id,'d'))) {
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Deleted Successfully!');
        $this->session->set_flashdata('msg', 'Customer data has been deleted successfully.');
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occured!');
        $this->session->set_flashdata('msg', 'Unable to process this request!');
      }
      return redirect(base_url('messages.php'));
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url());
    }
  }
  public function emailQuotes()
  {
    if (empty($this->session->userdata('loggedInSU'))) {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Access Denied!');
      $this->session->set_flashdata('msg', 'You need to signed in to access dashboard!');
      return redirect(base_url('login.php'));
    }
    $config['seoTitle'] = 'Email Quotes Dashboard | Instly Quote';
    $config['seoDesc'] = 'Email Quotes Dashboard | Instly Quote';
    $config['seoKey'] = 'Email Quotes Dashboard | Instly Quote';
    $this->load->view('theme/includes/login-sidebar', $config);
    $this->load->view('theme/email-quotes-dashbord');
    $this->load->view('theme/includes/login-footer');
  }
  public function emailQuotesDelete($id=null)
  {
    // debug($this->crud->getCount('requests', 'id', hashed($id,'d')),true);
    if (!empty($id) && $this->crud->getCount('requests_emails', 'id', hashed($id,'d')) > 0) {
      if ($this->crud->delete('requests_emails', 'id', hashed($id,'d'))) {
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Deleted Successfully!');
        $this->session->set_flashdata('msg', 'Customer data has been deleted successfully.');
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occured!');
        $this->session->set_flashdata('msg', 'Unable to process this request!');
      }
      return redirect(base_url('email-quotes.php'));
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url());
    }
  }
  public function deleteCustomerDataBulk()
  {
    if ($this->input->server('REQUEST_METHOD') === 'POST') {
      $requestsID = $this->input->post('requestsID');
      if (!empty($requestsID)) {
        foreach ($requestsID as $id) {
          @$this->crud->delete('requests', 'id', $id);
        }
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Customer Data Deleted!');
        $this->session->set_flashdata('msg', 'The selected customers has been deleted successfully.');
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occured!');
        $this->session->set_flashdata('msg', 'Unable to process your request');
      }
      return redirect(base_url('messages.php'));
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('messages.php'));
    }
  }
  public function deleteRequestsEmails()
  {
    if ($this->input->server('REQUEST_METHOD') === 'POST') {
      $requestsID = $this->input->post('requests_emails_ids');
      if (!empty($requestsID)) {
        foreach ($requestsID as $id) {
          @$this->crud->delete('requests_emails', 'id', $id);
        }
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Email Quotes Deleted!');
        $this->session->set_flashdata('msg', 'The selected email quotes has been deleted successfully.');
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occured!');
        $this->session->set_flashdata('msg', 'Unable to process your request');
      }
      return redirect(base_url('email-quotes.php'));
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('email-quotes.php'));
    }
  }
  public function export() {
    // Retrieve insurer data
    $requests = $this->crud->get_all_requests();
    // debug($requests,true);
    // Load the URL helper to use base_url()
    $this->load->helper('url');
    // Define the CSV file name
    $filename = 'customer-data-exported-sheet-' . date('Y-m-d') . '.csv';
    // Set headers for the CSV download
    header('Content-Type: text/csv; charset=utf-8');
    header('Content-Disposition: attachment; filename="' . $filename . '";');
    // Open the output stream
    $output = fopen('php://output', 'w');
    // Insert column headers
    fputcsv($output, array(
      'ID',
      'Full Name',
      'Continent',
      'Nationality',
      'Covered Person',
      'Covered Type',
      'Age',
      'Betterhalf Age',
      'Child Age',
      'Max Age',
      'Created'
    ));
    // Insert rows
    foreach ($requests as $request) {
      if (!empty($request['id'])) {
        $row = array(
          $request['id'],
          $request['fullname'],
          $request['continent'],
          $request['nationality'],
          $request['covered_person'],
          $request['covered_type'],
          $request['my_age'],
          $request['betterhalf_age'],
          $request['child_age'],
          $request['maxage'],
          $request['created']
        );
        fputcsv($output, $row);
      }
    }
    // Close the output stream
    fclose($output);
    exit;
  }
  public function exportEmailsAsCSV() {
    // Load necessary helper
    $this->load->helper('download');
    // Build query to fetch records based on date range
    $this->db->select('id, name, email, phone, policy_name, insurer_name, pid, rid, added');
    $this->db->from('requests_emails');
    // Fetch the records
    $query = $this->db->get();
    $requestsEmails = $query->result_array();
    // Initialize CSV content
    $csvContent = "ID, Name, Email, Phone, Policy ID, Policy Name, Insurer Name, Residence Country, Nationality, Covered Person, Age, Betterhalf Age, Child Age, Max Age, Added\n";
    // Loop through data to populate CSV rows
    foreach ($requestsEmails as $emailRequest) {
      $requestData = $this->crud->getDataSingle('requests', $emailRequest['rid'], 'id', null);
      if (!empty($requestData->child_age)) {
        $childage = str_replace(',','|',$requestData->child_age);
      } else {
        $childage = null;
      }
      $csvContent .= "{$emailRequest['id']},";
      $csvContent .= "{$emailRequest['name']},";
      $csvContent .= "{$emailRequest['email']},";
      $csvContent .= "{$emailRequest['phone']},";
      $csvContent .= "{$emailRequest['pid']},";
      $csvContent .= "{$emailRequest['policy_name']},";
      $csvContent .= "{$emailRequest['insurer_name']},";
      $csvContent .= "{$requestData->continent},";
      $csvContent .= "{$requestData->nationality},";
      $csvContent .= "{$requestData->covered_person},";
      $csvContent .= "{$requestData->my_age},";
      $csvContent .= "{$requestData->betterhalf_age},";
      $csvContent .= "{$childage},";
      $csvContent .= "{$requestData->maxage},";
      $csvContent .= date('d M Y - h:ia', strtotime($emailRequest['added'])) . "\n";
    }
    // Filename for the CSV
    $fileName = "email_requests_" . date('Y-m-d_h-i-A') . ".csv";
    // Force download the CSV file
    force_download($fileName, $csvContent);
  }
}
?>