<?php
defined('BASEPATH') OR exit('No direct script access allowed');
class Policy extends CI_Controller{
  public function index()
  {
    if (empty($this->session->userdata('loggedInSU'))) {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Access Denied!');
      $this->session->set_flashdata('msg', 'You need to signed in to access dashboard!');
      return redirect(base_url('login.php'));
    }
    $config['seoTitle'] = 'Policy Dashboard | Instly Quote';
    $config['seoDesc'] = 'Policy Dashboard | Instly Quote';
    $config['seoKey'] = 'Policy Dashboard | Instly Quote';
    $this->load->view('theme/includes/login-sidebar', $config);
    $this->load->view('theme/policy-dashboard');
    $this->load->view('theme/includes/login-footer');
  }
  public function getCountriesByRegion() {
    $region = $this->input->post('region_id');
    $regionData = $this->crud->getDataSingle('regions', $region, 'name', null); // Assuming you have a method to get a region by its ID
    $countries = $this->crud->getDataWhere('countries', ['region_id' => $regionData->id], 'name', 'asc'); // Assuming you have a method to get countries by region ID
    $data = [
      'region_name' => $regionData->name,
      'data' => $countries
    ];
    echo json_encode($data);
  }
  public function getDeductible() {
    if ($this->input->server('REQUEST_METHOD') === 'POST') {
      $iid = $this->input->post('iid');
      $getDeductibleFilesData = $this->crud->getDeductibleFiles($iid); 
      foreach ($getDeductibleFilesData as $getDeductibleFilesDetails) {
        echo '<option value="'.$getDeductibleFilesDetails->id.'">'.$getDeductibleFilesDetails->deductible_name.'</option>'.PHP_EOL;
      }
    } else {
      echo 'error';
    }
  }
  public function create()
  {
    if ($this->input->server('REQUEST_METHOD') === 'POST') {
      
      $data['insurer_id'] = $this->input->post('insurer_id');
      $data['policy_name'] = $this->input->post('policy_name');
      $data['loc'] = $this->input->post('loc') ?? null;
      $data['annual_limit'] = $this->input->post('annual_limit');
      $data['deductible'] = $this->input->post('deductible');
      $data['area_of_cover'] = (!empty($this->input->post('area_of_cover')))?implode(',',$this->input->post('area_of_cover')):null;
      $data['country'] = (!empty($this->input->post('country')))?implode(',',$this->input->post('country')):null;
      $data['facilities'] = $this->input->post('facilities');
      $data['inpatient_annual_limit'] = $this->input->post('inpatient_annual_limit');
      $data['inpatient_info_room_board'] = $this->input->post('inpatient_info_room_board');
      $data['inpatient_info_cancer'] = $this->input->post('inpatient_info_cancer');
      $data['inpatient_info_hospitalization_expenses'] = $this->input->post('inpatient_info_hospitalization_expenses');
      $data['inpatient_info_outpatient_surgery'] = $this->input->post('inpatient_info_outpatient_surgery');
      $data['inpatient_info_mri_ct_pet_scans'] = $this->input->post('inpatient_info_mri_ct_pet_scans');
      $data['inpatient_info_pre_post_hospitalization'] = $this->input->post('inpatient_info_pre_post_hospitalization');
      $data['inpatient_info_psychiatric_care'] = $this->input->post('inpatient_info_psychiatric_care');
      $data['inpatient_info_emergency_evacuation'] = $this->input->post('inpatient_info_emergency_evacuation');
      $data['outpatient_info_annual_limit'] = $this->input->post('outpatient_info_annual_limit');
      $data['outpatient_info_doctors_fee'] = $this->input->post('outpatient_info_doctors_fee');
      $data['outpatient_info_routine_tests'] = $this->input->post('outpatient_info_routine_tests');
      $data['outpatient_info_prescribed_drugs'] = $this->input->post('outpatient_info_prescribed_drugs');
      $data['outpatient_info_physiotherapy'] = $this->input->post('outpatient_info_physiotherapy');
      $data['outpatient_info_chiropractor'] = $this->input->post('outpatient_info_chiropractor');
      $data['outpatient_info_psychiatric_care'] = $this->input->post('outpatient_info_psychiatric_care');
      $data['outpatient_info_annual_health_checks'] = $this->input->post('outpatient_info_annual_health_checks');
      $data['outpatient_info_vaccines'] = $this->input->post('outpatient_info_vaccines');
      $data['dental_info_annual_limit'] = $this->input->post('dental_info_annual_limit');
      $data['dental_info_major_dental'] = $this->input->post('dental_info_major_dental');
      $data['dental_info_minor_dental'] = $this->input->post('dental_info_minor_dental');
      $data['dental_info_vision'] = $this->input->post('dental_info_vision');
      $data['maternity_annual_limit'] = $this->input->post('maternity_annual_limit');
      $data['maternity_routine_delivery'] = $this->input->post('maternity_routine_delivery');
      $data['maternity_outpatient_maternity'] = $this->input->post('maternity_outpatient_maternity');
      $data['maternity_maternity_complication'] = $this->input->post('maternity_maternity_complication');
      
      if ($this->crud->save('policies', $data, false)) {
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Data Saved!');
        $this->session->set_flashdata('msg', 'The policy data has been saved successfully.');
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occured!');
        $this->session->set_flashdata('msg', 'Unable to process the request!');
      }
      return redirect(base_url('policy.php'));
      
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('policy.php'));
    }
  }
  public function edit($id=null)
  {
    if (empty($this->session->userdata('loggedInSU'))) {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Access Denied!');
      $this->session->set_flashdata('msg', 'You need to signed in to access dashboard!');
      return redirect(base_url('login.php'));
    }
    if ($this->crud->getCount('policies', 'id', hashed($id,'d')) > 0) {
      $config['policyData'] = $this->crud->getDataSingle('policies', hashed($id,'d'), 'id', null);
      $config['seoTitle'] = 'Edit Policy Details | Instly Quote';
      $config['seoDesc'] = 'Edit Policy Details | Instly Quote';
      $config['seoKey'] = 'Edit Policy Details | Instly Quote';
      $this->load->view('theme/includes/login-sidebar', $config);
      $this->load->view('theme/policy-edit');
      $this->load->view('theme/includes/login-footer');
    }else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', '404 - Page Not Found');
      $this->session->set_flashdata('msg', 'Unable to find the policy!');
      return redirect(base_url('policy.php'));
    }
  }
  public function update()
  {
    if ($this->input->server('REQUEST_METHOD') === 'POST') {
      
      $id = hashed($this->input->post('pid'),'d');
      
      $data['insurer_id'] = $this->input->post('insurer_id') ?? null;
      $data['policy_name'] = $this->input->post('policy_name') ?? null;
      $data['loc'] = $this->input->post('loc');
      $data['annual_limit'] = $this->input->post('annual_limit') ?? null;
      $data['deductible'] = $this->input->post('deductible') ?? null;
      $data['area_of_cover'] = (!empty($this->input->post('area_of_cover')))?implode(',',$this->input->post('area_of_cover')):null ?? null;
      $data['country'] = (!empty($this->input->post('country')))?implode(',',$this->input->post('country')):null ?? null;
      $data['facilities'] = $this->input->post('facilities') ?? null;
      $data['inpatient_annual_limit'] = $this->input->post('inpatient_annual_limit') ?? null;
      $data['inpatient_info_room_board'] = $this->input->post('inpatient_info_room_board') ?? null;
      $data['inpatient_info_cancer'] = $this->input->post('inpatient_info_cancer') ?? null;
      $data['inpatient_info_hospitalization_expenses'] = $this->input->post('inpatient_info_hospitalization_expenses') ?? null;
      $data['inpatient_info_outpatient_surgery'] = $this->input->post('inpatient_info_outpatient_surgery') ?? null;
      $data['inpatient_info_mri_ct_pet_scans'] = $this->input->post('inpatient_info_mri_ct_pet_scans') ?? null;
      $data['inpatient_info_pre_post_hospitalization'] = $this->input->post('inpatient_info_pre_post_hospitalization') ?? null;
      $data['inpatient_info_psychiatric_care'] = $this->input->post('inpatient_info_psychiatric_care') ?? null;
      $data['inpatient_info_emergency_evacuation'] = $this->input->post('inpatient_info_emergency_evacuation') ?? null;
      $data['outpatient_info_annual_limit'] = $this->input->post('outpatient_info_annual_limit') ?? null;
      $data['outpatient_info_doctors_fee'] = $this->input->post('outpatient_info_doctors_fee') ?? null;
      $data['outpatient_info_routine_tests'] = $this->input->post('outpatient_info_routine_tests') ?? null;
      $data['outpatient_info_prescribed_drugs'] = $this->input->post('outpatient_info_prescribed_drugs') ?? null;
      $data['outpatient_info_physiotherapy'] = $this->input->post('outpatient_info_physiotherapy') ?? null;
      $data['outpatient_info_chiropractor'] = $this->input->post('outpatient_info_chiropractor') ?? null;
      $data['outpatient_info_psychiatric_care'] = $this->input->post('outpatient_info_psychiatric_care') ?? null;
      $data['outpatient_info_annual_health_checks'] = $this->input->post('outpatient_info_annual_health_checks') ?? null;
      $data['outpatient_info_vaccines'] = $this->input->post('outpatient_info_vaccines') ?? null;
      $data['dental_info_annual_limit'] = $this->input->post('dental_info_annual_limit') ?? null;
      $data['dental_info_major_dental'] = $this->input->post('dental_info_major_dental') ?? null;
      $data['dental_info_minor_dental'] = $this->input->post('dental_info_minor_dental') ?? null;
      $data['dental_info_vision'] = $this->input->post('dental_info_vision') ?? null;
      $data['maternity_annual_limit'] = $this->input->post('maternity_annual_limit') ?? null;
      $data['maternity_routine_delivery'] = $this->input->post('maternity_routine_delivery') ?? null;
      $data['maternity_outpatient_maternity'] = $this->input->post('maternity_outpatient_maternity') ?? null;
      $data['maternity_maternity_complication'] = $this->input->post('maternity_maternity_complication') ?? null;
      
      if ($this->crud->update('policies', 'id', $id, $data)) {
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Data Updated!');
        $this->session->set_flashdata('msg', 'The policy data has been updated successfully.');
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occured!');
        $this->session->set_flashdata('msg', 'Unable to process the request!');
      }
      return redirect(base_url('policy.php'));
      
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('policy.php'));
    }
  }
  public function delete($id=null)
  {
    if (empty($this->session->userdata('loggedInSU'))) {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Access Denied!');
      $this->session->set_flashdata('msg', 'You need to signed in to access dashboard!');
      return redirect(base_url('login.php'));
    }
    if ($this->crud->getCount('policies', 'id', hashed($id,'d')) > 0) {
      if ($this->crud->delete('policies', 'id', hashed($id,'d'))) {
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Policy Deleted!');
        $this->session->set_flashdata('msg', 'The policy has been removed successfully.');
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occured!');
        $this->session->set_flashdata('msg', 'Unable to process your request!');
      }
      return redirect(base_url('policy.php'));
    }else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', '404 - Page Not Found');
      $this->session->set_flashdata('msg', 'Unable to find the policy!');
      return redirect(base_url('policy.php'));
    }
  }
  public function deletePolicyBulk()
  {
    if ($this->input->server('REQUEST_METHOD') === 'POST') {
      $policyID = $this->input->post('policyID');
      if (!empty($policyID)) {
        foreach ($policyID as $id) {
          @$this->crud->delete('policies', 'id', $id);
        }
        $this->session->set_flashdata('type', 'success');
        $this->session->set_flashdata('title', 'Policy Deleted!');
        $this->session->set_flashdata('msg', 'The selected policy has been deleted successfully.');
      } else {
        $this->session->set_flashdata('type', 'error');
        $this->session->set_flashdata('title', 'Error Occured!');
        $this->session->set_flashdata('msg', 'Unable to process your request');
      }
      return redirect(base_url('policy.php'));
    } else {
      $this->session->set_flashdata('type', 'error');
      $this->session->set_flashdata('title', 'Error');
      $this->session->set_flashdata('msg', 'No direct script access allowed.');
      return redirect(base_url('policy.php'));
    }
  }
  public function export() {
    // Retrieve policy data
    $policies = $this->crud->get_all_policies();
    
    // Load the URL helper to use base_url()
    $this->load->helper('url');
    
    // Define the CSV file name
    $filename = 'policies-exported-sheet-' . date('Y-m-d') . '.csv';
    
    // Set headers for the CSV download
    header('Content-Type: text/csv; charset=utf-8');
    header('Content-Disposition: attachment; filename="' . $filename . '";');
    
    // Open the output stream
    $output = fopen('php://output', 'w');
    
    // Insert column headers
    fputcsv($output, array(
      'ID', 
      'Insurer ID', 
      'Policy Name', 
      'Annual Limit', 
      'Deductible', 
      'Area of Cover', 
      'Country', 
      'Facilities', 
      'Inpatient Annual Limit', 
      'Inpatient Info Room Board', 
      'Inpatient Info Cancer', 
      'Inpatient Info Hospitalization Expenses', 
      'Inpatient Info Outpatient Surgery', 
      'Inpatient Info MRI/CT/PET Scans', 
      'Inpatient Info Pre/Post Hospitalization', 
      'Inpatient Info Psychiatric Care', 
      'Inpatient Info Emergency Evacuation', 
      'Outpatient Info Annual Limit', 
      'Outpatient Info Doctors Fee', 
      'Outpatient Info Routine Tests', 
      'Outpatient Info Prescribed Drugs', 
      'Outpatient Info Physiotherapy', 
      'Outpatient Info Chiropractor', 
      'Outpatient Info Psychiatric Care', 
      'Outpatient Info Annual Health Checks', 
      'Outpatient Info Vaccines', 
      'Dental Info Annual Limit', 
      'Dental Info Major Dental', 
      'Dental Info Minor Dental', 
      'Dental Info Vision', 
      'Maternity Annual Limit', 
      'Maternity Routine Delivery', 
      'Maternity Outpatient Maternity', 
      'Maternity Maternity Complication', 
      'Deleted', 
      'Status', 
      'Added', 
      'Updated'
    ));
    
    // Insert rows
    foreach ($policies as $policy) {
      $row = array(
        $policy['id'],
        $policy['insurer_id'],
        $policy['policy_name'],
        $policy['annual_limit'],
        $policy['deductible'],
        $policy['area_of_cover'],
        $policy['country'],
        $policy['facilities'],
        $policy['inpatient_annual_limit'],
        $policy['inpatient_info_room_board'],
        $policy['inpatient_info_cancer'],
        $policy['inpatient_info_hospitalization_expenses'],
        $policy['inpatient_info_outpatient_surgery'],
        $policy['inpatient_info_mri_ct_pet_scans'],
        $policy['inpatient_info_pre_post_hospitalization'],
        $policy['inpatient_info_psychiatric_care'],
        $policy['inpatient_info_emergency_evacuation'],
        $policy['outpatient_info_annual_limit'],
        $policy['outpatient_info_doctors_fee'],
        $policy['outpatient_info_routine_tests'],
        $policy['outpatient_info_prescribed_drugs'],
        $policy['outpatient_info_physiotherapy'],
        $policy['outpatient_info_chiropractor'],
        $policy['outpatient_info_psychiatric_care'],
        $policy['outpatient_info_annual_health_checks'],
        $policy['outpatient_info_vaccines'],
        $policy['dental_info_annual_limit'],
        $policy['dental_info_major_dental'],
        $policy['dental_info_minor_dental'],
        $policy['dental_info_vision'],
        $policy['maternity_annual_limit'],
        $policy['maternity_routine_delivery'],
        $policy['maternity_outpatient_maternity'],
        $policy['maternity_maternity_complication'],
        $policy['deleted'],
        $policy['status'],
        $policy['added'],
        $policy['updated']
      );
      fputcsv($output, $row);
    }
    
    // Close the output stream
    fclose($output);
    exit;
  }
  
}
?>