<?php defined('BASEPATH') OR exit('No direct script access allowed');

class FileManager {
  public $dir;
  public $url;
  function __construct($curDir = null) {
    $this->dir = 'upload/Vikas';
  }
  function fileList() {
    $files = array_slice(scandir($this->dir), 2);
    $list = array();
    for ($i = 0; $i < sizeof($files); $i++) {
      $type = filetype($this->dir . '/' . $files[$i]);
      $download = "?download={$files[$i]}&type={$type}&curDir={$this->dir}";
      $list[] = array(
        'file' => $files[$i],
        'type' => $type,
        'download' => $download,
        'delete' => "?delete={$files[$i]}&type={$type}&curDir={$this->dir}",
        'view' => ($type == 'dir') ? "?goDir={$this->dir}/{$files[$i]}&curDir={$this->dir}" : $download,
      );
    }
    return $list;
  }
  function rename($data) {
   $info = rename($data['curDir'] . '/' . $data['rename'], $data['curDir'] . '/' . $data['newName']);
   $this->dir = $data['curDir'];
  }
  function download($data) {
    if ($data['type'] == 'file') {
      $file=$data['curDir'] . '/' . $data['download'];
      header('Content-Description: File Transfer');
      header("Content-Type:application/octet-stream");
      header("Accept-Ranges: bytes");
      header("Content-Length: " . filesize($file));
      header('Expires: 0');
      header('Cache-Control: must-revalidate');
      header('Pragma: public');
      header("Content-Disposition: attachment; filename=" . $data['download']);
      flush(); // Flush system output buffer
      readfile($file);
      exit;
    } else if ($data['type'] == 'dir') {
      echo 'zip download not done.......<br>';
    }
  }
  function delete($data) {
    if ($data['type'] == 'dir') {
      $info = rmdir($data['curDir'] . '/' . $data['delete']);
    } else if ($data['type'] == 'file') {
      $info = unlink($data['curDir'] . '/' . $data['delete']);
    }
    $this->dir = $data['curDir'];
  }
  function goDir($dir) {
    $this->dir = $dir;
  }
  function backDir($dir) {
    $dirAr = explode('/', $dir);
    array_pop($dirAr);
    $bkdir = implode('/', $dirAr);
    $this->dir = $bkdir;
  }
  function createFolder($data) {
   $info = mkdir($data['curDir'] . '/' . $data['createFolder'], 0777);
   $this->dir = $data['curDir'];
  }
  function filesUpload($files, $dir) {
    for ($i = 0; $i < sizeof($files['filesUpload']['error']); $i++) {
      if ($files['filesUpload']['error'][$i] == 0){
        move_uploaded_file($files['filesUpload']['tmp_name'][$i], $dir . '/' . $files['filesUpload']['name'][$i]);
      }
    }
    $this->dir = $dir;
  }
  function auto($get, $files, $post) { 
    //go
    if (isset($get['goDir'])) {
      $this->goDir($get['goDir']);
    }
    //back
    if (isset($get['backDir'])) {
      $this->backDir($get['backDir']);
    }
    //rename
    if (isset($get['rename'])) {
      $this->rename($get);
    }
    //download
    if (isset($get['download'])) {
      $this->download($get);
    }
    //delete
    if (isset($get['delete'])) {
      $this->delete($get);
    }
    //createFolder
    if (isset($get['createFolder'])) {
      $this->createFolder($get);
    }
    //filesUpload
    if (isset($files['filesUpload'])) {
      $this->filesUpload($files, $get['curDir']);
    }
    return error_get_last();
  }
}
