// Function to trigger the alert box
function triggerAlert(type, message) {
  const alertBox = document.getElementById('alertBox');
  const alertIcon = document.getElementById('alertIcon');
  const alertText = document.getElementById('alertText');
  // Reset classes
  alertBox.className = 'alert-box';
  alertIcon.className = 'icon';
  // Set the message and icon based on the type
  switch(type) {
    case 'success':
    alertBox.classList.add('alert-success');
    alertIcon.textContent = '✔';
    break;
    case 'error':
    alertBox.classList.add('alert-error');
    alertIcon.textContent = '✖';
    break;
    case 'warning':
    alertBox.classList.add('alert-warning');
    alertIcon.textContent = '⚠';
    break;
    default:
    break;
  }
  // Set the alert message
  alertText.textContent = message;
  // Show the alert box
  alertBox.style.display = 'flex';
  // Hide the alert box after 3 seconds
  setTimeout(() => {
    alertBox.style.display = 'none';
  }, 3000);
}
document.addEventListener('DOMContentLoaded', function () {
  var form = document.querySelector('.form-insurer');
  window.Parsley.on('form:error', function() {
    // Find the first error field
    var firstErrorField = form.querySelector('.parsley-error');
    if (firstErrorField) {
      // Smooth scroll to the first error element
      firstErrorField.scrollIntoView({
        behavior: 'smooth',
        block: 'center'
      });
      // Apply the shaky animation after the scroll completes
      setTimeout(function() {
        firstErrorField.classList.add('shakey-animation');
        // Remove the shaky animation class after animation ends
        setTimeout(function() {
          firstErrorField.classList.remove('shakey-animation');
        }, 500); // 500ms = duration of the shake animation
      }, 600); // Wait for the scroll to complete before shaking (adjust time if needed)
    }
  });
});