$(document).ready(function() {
  var table = $('#email-table').DataTable({
    "columnDefs": [
      {
        "targets": 1, // The index of the checkbox column (second column, so index is 1)
        "orderable": false // Disable sorting on this column
      },
      {
        "targets": 0, // The index of the Sr. column (first column, so index is 0)
        "visible": false // Hide the Sr. column
      }
    ],
    "initComplete": function () {
      // Add a placeholder to the search input
      $('#email-table_wrapper .dt-search input').attr('placeholder', 'Search Email Quotes...');
    }
  });
});
document.addEventListener('DOMContentLoaded', function () {
  const checkAll = document.getElementById('check-all');
  const checkboxes = document.querySelectorAll('.row-checkbox');
  const deleteButtonContainer = document.getElementById('delete-button-container');
  // Function to show/hide delete button based on selection
  function toggleDeleteButton() {
    const anyChecked = [...checkboxes].some(checkbox => checkbox.checked);
    deleteButtonContainer.style.display = anyChecked ? 'block' : 'none';
  }
  // Handle "check all" functionality
  checkAll.addEventListener('change', function () {
    const checkedStatus = this.checked;
    checkboxes.forEach(checkbox => checkbox.checked = checkedStatus);
    toggleDeleteButton();
  });
  // Handle individual checkbox changes
  checkboxes.forEach(checkbox => {
    checkbox.addEventListener('change', function () {
      toggleDeleteButton();
    });
  });
});