$(document).ready(function() {
  var table = $('#companylist-table-1').DataTable({
    "columnDefs": [
      {
        "targets": 1, // The index of the checkbox column (second column, so index is 1)
        "orderable": false // Disable sorting on this column
      },
      {
        "targets": 0, // The index of the Sr. column (first column, so index is 0)
        "visible": false // Hide the Sr. column
      }
    ],
    "initComplete": function () {
  // Add a placeholder to the search input
  $('#companylist-table-1_wrapper .dt-search input').attr('placeholder', 'Search Insurer...');
  }
    
  });
  var checkboxState = {};
  
  // Handle click on "Select all" control
  $('#select-all').on('click', function() {
    var isChecked = this.checked;
    $('input.row-checkbox').each(function() {
      $(this).prop('checked', isChecked);
      checkboxState[$(this).val()] = isChecked;
    });
    toggleDeleteButton();
  });
  
  // Handle click on checkboxes
  $('#companylist-table-1 tbody').on('click', '.row-checkbox', function() {
    checkboxState[$(this).val()] = $(this).prop('checked');
    if ($('input.row-checkbox:checked').length === $('input.row-checkbox').length) {
      $('#select-all').prop('checked', true);
    } else {
      $('#select-all').prop('checked', false);
    }
    toggleDeleteButton();
  });
  
  // On each draw event, restore the state of checkboxes
  table.on('draw', function() {
    $('input.row-checkbox').each(function() {
      if (checkboxState[$(this).val()]) {
        $(this).prop('checked', true);
      }
    });
    toggleDeleteButton();
  });
  
  function toggleDeleteButton() {
    if ($('input.row-checkbox:checked').length > 0) {
      $('#delete-button').show();
    } else {
      $('#delete-button').hide();
    }
  }
  // Handle the delete button click event
  $('#delete-button').on('click', function(e) {
    e.preventDefault(); // Prevent the default form submission
    
    swal({
      title: "Are you sure?",
      text: "You won't be able to revert this!",
      icon: "warning",
      buttons: true,
      dangerMode: true,
    })
    .then((willDelete) => {
      if (willDelete) {
        $('#deleteInsurer').submit(); // Submit the form if confirmed
      }
    });
  });
});
$(document).ready(function() {
  // Initialize area count based on existing cards
  let areaCount = $('#mainCardBox .deduct-card').length;
  $('#addNewArea').on('click', function(){
    addNewArea();
  });
  function addNewArea() {
    let content = `<div class="deduct-card">
    <div class="component-list">
    <label for="email" class="control-label">Area Name<span class="text-danger">*</span></label>
    <div class="col-full">
    <input type="text" name="deductible_name[${areaCount}][]" id="" class="control-input" placeholder="Area ${areaCount + 1} Worldwide" required>
    </div>
    </div>
    <div class="xcsv-file">
    <div class="applicant-file">
    <input type="file" name="deductible_file[${areaCount}][]" class="upload fileupdate-list file-deduct" accept=".csv" id="file-input-csv" required>
    <label for="file-deduct" class="my-3 file-label-deduct">
    <span tabindex="-1" class="upload_tagline"><span
    class="text-primary">Upload</span> csv file only <span class="text-danger">*</span></span>
    </label>
    </div>
    </div>
    <div class="row-heading">
    <div class="space-deductible"> Deductible <span class="text-danger">*</span></div>
    <div class="space-rate">Rate % <span class="text-danger">*</span></div>
    </div>
    <div class="clone-container">
    <div class="row-heading addmore-row">
    <div class="space-deductible"> 
    <input type="text" name="deductible_rate_amount[${areaCount}][]" id="" class="control-input" placeholder="" required="" data-parsley-trigger="change" >
    </div>
    <div class="space-rate">
    <input type="text" name="deductible_rate[${areaCount}][]" id="" class="control-input" placeholder="" required="" data-parsley-trigger="change"> 
    </div>
    <div class="icons-space remove-current">
    <img src="https://dp-client.com/insurance/icons/icons-red-remove.svg" alt="delete current">
    </div>
    </div>
    </div>
    <div class="themore-add">
    <button type="button" class="btn-more addmore-deduct">
    <svg xmlns="http://www.w3.org/2000/svg" width="25" height="24" viewBox="0 0 25 24" fill="none">
    <path d="M11.5 13H5.5V11H11.5V5H13.5V11H19.5V13H13.5V19H11.5V13Z" fill="#8A97AA"/>
    </svg> Add New
    </button>
    <button type="button" class="btn-more delete-current">
    <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 16 16" fill="none">
    <path fill-rule="evenodd" clip-rule="evenodd" d="M5.75 3V1.5H10.25V3H5.75ZM4.25 3V1C4.25 0.734784 4.35536 0.48043 4.54289 0.292893C4.73043 0.105357 4.98478 0 5.25 0L10.75 0C11.0152 0 11.2696 0.105357 11.4571 0.292893C11.6446 0.48043 11.75 0.734784 11.75 1V3H14.25C14.4489 3 14.6397 3.07902 14.7803 3.21967C14.921 3.36032 15 3.55109 15 3.75C15 3.94891 14.921 4.13968 14.7803 4.28033C14.6397 4.42098 14.4489 4.5 14.25 4.5H13.885L13.142 14.153C13.1034 14.6554 12.8767 15.1248 12.507 15.4673C12.1373 15.8097 11.6519 16 11.148 16H4.852C4.34808 16 3.86274 15.8097 3.49304 15.4673C3.12335 15.1248 2.89655 14.6554 2.858 14.153L2.115 4.5H1.75C1.55109 4.5 1.36032 4.42098 1.21967 4.28033C1.07902 4.13968 1 3.94891 1 3.75C1 3.55109 1.07902 3.36032 1.21967 3.21967C1.36032 3.07902 1.55109 3 1.75 3H4.25ZM3.62 4.5H12.38L11.646 14.038C11.6364 14.1636 11.5798 14.2809 11.4875 14.3666C11.3952 14.4522 11.2739 14.4999 11.148 14.5H4.852C4.72607 14.4999 4.60482 14.4522 4.5125 14.3666C4.42017 14.2809 4.36357 14.1636 4.354 14.038L3.62 4.5Z" fill="#ED5C5C"/>
    </svg> Delete table 
    </button>
    </div>
    </div>`;
    $('#mainCardBox').append(content);
    attachDeleteEvent();
    attachAddMoreDeductEvent();
    areaCount++;
  }
  function attachDeleteEvent() {
    $('.delete-current').off('click').on('click', function() {
      if ($('#mainCardBox .deduct-card').length > 1) {
        $(this).closest('.deduct-card').remove();
        resetAreaCount();
      } else {
        swal({
          title: "Error Occurred!",
          text: "You must have at least one item.",
          icon: "error",
          button: false,
          timer: 2500
        });
      }
    });
  }
  function resetAreaCount() {
    areaCount = 0;
    $('#mainCardBox .deduct-card').each(function(index) {
      $(this).find('input[name^="deductible_name"]').attr('name', `deductible_name[${index}][]`);
      $(this).find('input[name^="deductible_file"]').attr('name', `deductible_file[${index}][]`);
      $(this).find('input[name^="deductible_rate_amount"]').attr('name', `deductible_rate_amount[${index}][]`);
      $(this).find('input[name^="deductible_rate"]').attr('name', `deductible_rate[${index}][]`);
      areaCount++;
    });
  }
  function attachAddMoreDeductEvent() {
    $('.addmore-deduct').off('click').on('click', function() {
      const $cloneContainer = $(this).closest('.deduct-card').find('.clone-container');
      const index = $cloneContainer.closest('.deduct-card').index();
      const newRow = `
      <div class="row-heading addmore-row">
      <div class="space-deductible">
      <input type="text" name="deductible_rate_amount[${index}][]" class="control-input" placeholder="" required="" data-parsley-type="number" data-parsley-trigger="change">
      </div>
      <div class="space-rate">
      <input type="text" name="deductible_rate[${index}][]" class="control-input" placeholder="" required="" data-parsley-type="number" data-parsley-trigger="change">
      </div>
      <div class="icons-space remove-current">
      <img src="https://dp-client.com/insurance/icons/icons-red-remove.svg" alt="delete current">
      </div>
      </div>`;
      $cloneContainer.append(newRow);
      attachRemoveCurrentEvent();
    });
  }
  function attachRemoveCurrentEvent() {
    $('.remove-current').off('click').on('click', function() {
      const $cloneContainer = $(this).closest('.clone-container');
      if ($cloneContainer.find('.addmore-row').length > 1) {
        $(this).closest('.addmore-row').remove();
      } else {
        swal({
          title: "Error Occurred!",
          text: "You must have at least one item.",
          icon: "error",
          button: false,
          timer: 2500
        });
      }
    });
  }
  // Attach events to existing cards (if any)
  attachDeleteEvent();
  attachAddMoreDeductEvent();
  attachRemoveCurrentEvent();
});