document.addEventListener('DOMContentLoaded', function() {
  // Function to toggle the visibility of content
  function toggleContent(button) {
    const target = document.querySelector(button.getAttribute('data-target'));
    if (target.style.display === "none" || target.style.display === "") {
      target.style.display = "block";
      target.style.maxHeight = target.scrollHeight + "px"; // Slide in effect
      button.textContent = 'Hide Table';
    } else {
      target.style.maxHeight = 0; // Slide out effect
      setTimeout(() => {
        target.style.display = "none";
      }, 300); // Matches the transition time
      button.textContent = 'Show Table';
    }
  }
  // Attach event listeners to all toggle buttons
  const buttons = document.querySelectorAll('.toggleButton');
  buttons.forEach(button => {
    button.addEventListener('click', function() {
      toggleContent(this);
    });
  });
});
$(document).ready(function() {
  $('#insurrerUpdateForm').on('submit', function(e) {
    e.preventDefault();
    // Create a FormData object and add the form data
    var formData = new FormData(this);
    $.ajax({
      url: 'https://dp-client.com/insurance/dashboard/updateInsureDetails', // Adjust this to your controller/method
      type: 'POST',
      data: formData,
      contentType: false,
      processData: false,
      dataType: 'json',
      success: function(response) {
        if (response.status == 'success') {
          swal({
            title: "Updated Successfully!",
            text: "Insurer details updated successfully.",
            icon: "success",
            button: false,
            timer: 2500
          });
          // Optionally redirect or reload
        } else {
          swal({
            title: "Updated Successfully!",
            text: "Insurer details updated successfully.",
            icon: "success",
            button: false,
            timer: 2500
          });
          swal({
            title: "Error Occurred!",
            text: "Failed to update insurer details!",
            icon: "error",
            button: false,
            timer: 2500
          });
        }
      },
      error: function(xhr, status, error) {
        console.error(xhr.responseText);
        swal({
          title: "Error Occurred!",
          text: "An error occurred! Please try again!",
          icon: "error",
          button: false,
          timer: 2500
        });
      }
    });
  });
});
function deleteDeductableData(boxID, deductableID, insurerID){
  $.ajax({
    url: 'https://dp-client.com/insurance/dashboard/deleteDeductable',
    type: 'POST',
    data: {deductableID:deductableID, insurerID:insurerID}
  })
  .done(function(res) {
    if (res == 'success') {
      console.log(res);
      $('#'+boxID).slideUp();
      swal({
        title: "Table Deleted!",
        text: "The table has been deleted successfully!",
        icon: "success",
        button: false,
        timer: 2500
      });
    }else{
      swal({
        title: "Error Occurred!",
        text: "An error occurred! Please try again!",
        icon: "error",
        button: false,
        timer: 2500
      });
    }
  })
  .fail(function() {
    console.log("error");
    swal({
      title: "Error Occurred!",
      text: "An error occurred! Please try again!",
      icon: "error",
      button: false,
      timer: 2500
    });
  });
}
$(document).ready(function() {
  // Initialize area count based on existing cards
  let areaCount = $('#mainCardBox .deduct-card').length;
  $('#addNewArea').on('click', function(){
    addNewArea(InsurerDataID);
  });
  function addNewArea(InsurerDataID) {
    let content = `<form action="https://dp-client.com/insurance/dashboard/addNewDeductable" id="addNewDeductable" method="post">
    <div class="deduct-card">
    <div class="component-list">
    <label for="email" class="control-label">Area Name<span class="text-danger">*</span></label>
    <div class="col-full">
    <input type="text" name="deductible_name" id="" class="control-input" placeholder="Area ${areaCount + 1} Worldwide" required>
    </div>
    </div>
    <div class="xcsv-file">
    <div class="applicant-file">
    <input type="file" name="deductible_file" class="upload fileupdate-list file-deduct" accept=".csv" id="file-input-csv" required>
    <label for="file-deduct" class="my-3 file-label-deduct">
    <span tabindex="-1" class="upload_tagline"><span
    class="text-primary">Upload</span> csv file only <span class="text-danger">*</span></span>
    </label>
    </div>
    </div>
    <div class="row-heading">
    <div class="space-deductible"> Deductible <span class="text-danger">*</span></div>
    <div class="space-rate">Rate % <span class="text-danger">*</span></div>
    </div>
    <div class="clone-container">
    <div class="row-heading addmore-row">
    <div class="space-deductible"> 
    <input type="text" name="deductible_rate_amount[]" id="" class="control-input" placeholder="" required="" data-parsley-trigger="change" >
    </div>
    <div class="space-rate">
    <input type="text" name="deductible_rate[]" id="" class="control-input" placeholder="" required="" data-parsley-trigger="change"> 
    </div>
    <div class="icons-space remove-current">
    <img src="https://dp-client.com/insurance/icons/icons-red-remove.svg" alt="delete current">
    </div>
    </div>
    </div>
    <div class="themore-add">
    <button type="button" class="btn-more addmore-deduct">
    <svg xmlns="http://www.w3.org/2000/svg" width="25" height="24" viewBox="0 0 25 24" fill="none">
    <path d="M11.5 13H5.5V11H11.5V5H13.5V11H19.5V13H13.5V19H11.5V13Z" fill="#8A97AA"/>
    </svg> Add New
    </button>
    <div style="display: flex; justify-content: space-between; gap: 20px;">
    <button type="submit" class="btn-more save-table" style="align-items: center; justify-content: center; border: 1px solid #4CAF50; color: #4CAF50; background-color: transparent; margin-top: 2rem;">
    <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 24 24" fill="none" stroke="#4CAF50" stroke-width="2" stroke-linecap="round" stroke-linejoin="round">
    <path d="M19 21H5a2 2 0 0 1-2-2V5a2 2 0 0 1 2-2h11l5 5v11a2 2 0 0 1-2 2z"/>
    <polyline points="17 21 17 13 7 13 7 21"/>
    <polyline points="7 3 7 8 15 8"/>
    </svg> Save Table
    </button>
    <button type="button" class="btn-more delete-current">
    <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" viewBox="0 0 16 16" fill="none">
    <path fill-rule="evenodd" clip-rule="evenodd" d="M5.75 3V1.5H10.25V3H5.75ZM4.25 3V1C4.25 0.734784 4.35536 0.48043 4.54289 0.292893C4.73043 0.105357 4.98478 0 5.25 0L10.75 0C11.0152 0 11.2696 0.105357 11.4571 0.292893C11.6446 0.48043 11.75 0.734784 11.75 1V3H14.25C14.4489 3 14.6397 3.07902 14.7803 3.21967C14.921 3.36032 15 3.55109 15 3.75C15 3.94891 14.921 4.13968 14.7803 4.28033C14.6397 4.42098 14.4489 4.5 14.25 4.5H13.885L13.142 14.153C13.1034 14.6554 12.8767 15.1248 12.507 15.4673C12.1373 15.8097 11.6519 16 11.148 16H4.852C4.34808 16 3.86274 15.8097 3.49304 15.4673C3.12335 15.1248 2.89655 14.6554 2.858 14.153L2.115 4.5H1.75C1.55109 4.5 1.36032 4.42098 1.21967 4.28033C1.07902 4.13968 1 3.94891 1 3.75C1 3.55109 1.07902 3.36032 1.21967 3.21967C1.36032 3.07902 1.55109 3 1.75 3H4.25ZM3.62 4.5H12.38L11.646 14.038C11.6364 14.1636 11.5798 14.2809 11.4875 14.3666C11.3952 14.4522 11.2739 14.4999 11.148 14.5H4.852C4.72607 14.4999 4.60482 14.4522 4.5125 14.3666C4.42017 14.2809 4.36357 14.1636 4.354 14.038L3.62 4.5Z" fill="#ED5C5C"/>
    </svg> Delete table 
    </button>
    </div>
    </div>
    </div>
    <input type="hidden" name="iid" value="${InsurerDataID}" />
    </form>`;
    $('#mainCardBox').append(content);
    attachDeleteEvent();
    attachAddMoreDeductEvent();
    areaCount++;
  }
  function attachDeleteEvent() {
    $('.delete-current').off('click').on('click', function() {
      // if ($('#mainCardBox .deduct-card').length > 1) {
      if (2 > 1) {
        $(this).closest('.deduct-card').remove();
        resetAreaCount();
      } else {
        swal({
          title: "Error Occurred!",
          text: "You must have at least one item.",
          icon: "error",
          button: false,
          timer: 2500
        });
      }
    });
  }
  function resetAreaCount() {
    areaCount = 0;
    $('#mainCardBox .deduct-card').each(function(index) {
      $(this).find('input[name^="deductible_name"]').attr('name', `deductible_name`);
      $(this).find('input[name^="deductible_file"]').attr('name', `deductible_file`);
      $(this).find('input[name^="deductible_rate_amount"]').attr('name', `deductible_rate_amount[]`);
      $(this).find('input[name^="deductible_rate"]').attr('name', `deductible_rate[]`);
      areaCount++;
    });
  }
  function attachAddMoreDeductEvent() {
    $('.addmore-deduct').off('click').on('click', function() {
      const $cloneContainer = $(this).closest('.deduct-card').find('.clone-container');
      const index = $cloneContainer.closest('.deduct-card').index();
      const newRow = `
      <div class="row-heading addmore-row">
      <div class="space-deductible">
      <input type="text" name="deductible_rate_amount[]" class="control-input" placeholder="" required="" data-parsley-type="number" data-parsley-trigger="change">
      </div>
      <div class="space-rate">
      <input type="text" name="deductible_rate[]" class="control-input" placeholder="" required="" data-parsley-type="number" data-parsley-trigger="change">
      </div>
      <div class="icons-space remove-current">
      <img src="https://dp-client.com/insurance/icons/icons-red-remove.svg" alt="delete current">
      </div>
      </div>`;
      $cloneContainer.append(newRow);
      attachRemoveCurrentEvent();
    });
  }
  function attachRemoveCurrentEvent() {
    $('.remove-current').off('click').on('click', function() {
      const $cloneContainer = $(this).closest('.clone-container');
      if ($cloneContainer.find('.addmore-row').length > 1) {
        $(this).closest('.addmore-row').remove();
      } else {
        swal({
          title: "Error Occurred!",
          text: "You must have at least one item.",
          icon: "error",
          button: false,
          timer: 2500
        });
      }
    });
  }
  // AJAX form submission
  $('#mainCardBox').on('click', '.save-table', function(event) {
    event.preventDefault(); // Prevent the default form submission behavior
    let formData = new FormData($('#addNewDeductable')[0]);
    $.ajax({
      url: "https://dp-client.com/insurance/dashboard/saveDeductableData",
      type: "POST",
      data: formData,
      contentType: false,
      processData: false,
      success: function(response) {
        try {
          let jsonResponse = JSON.parse(response);
          if (jsonResponse.status === 'success') {
            swal({
              title: "Saved Successfully!",
              text: "Data saved successfully.",
              icon: "success",
              button: false,
              timer: 2500
            }).then(() => {
              // Disable all form fields
              $('#addNewDeductable').find('input, select, textarea, button').prop('disabled', true);
              // Disable the delete button
              $('.delete-button').prop('disabled', true);
              // Optionally, reset the form if needed
              // $('#addNewDeductable')[0].reset(); 
            });
          } else {
            swal({
              title: "Error Occured!",
              text: "Unable to process the data!",
              icon: "error",
              button: false,
              timer: 2500
            });
            console.log('Error: ' + (jsonResponse.message || 'Failed to save data.'));
          }
        } catch (e) {
          console.error('Invalid JSON response:', response);
          swal({
            title: "Error Occured!",
            text: "Unexpected error occurred. Please try again!",
            icon: "error",
            button: false,
            timer: 2500
          });
        }
      },
      error: function(xhr, status, error) {
        console.error('Error saving data:', error);
        swal({
          title: "Error Occured!",
          text: "Error saving data. Please try again!",
          icon: "error",
          button: false,
          timer: 2500
        });
      }
    });
    // Attach events to existing cards (if any)
    attachDeleteEvent();
    attachAddMoreDeductEvent();
    attachRemoveCurrentEvent();
  });
});
function updateField(elID, type, id){
  $('#'+elID).attr('type', 'number');
  let elVal = $('#'+elID).val();
  $.ajax({
    url: 'https://dp-client.com/insurance/dashboard/updateField',
    type: 'POST',
    data: {type:type, id:id, value:elVal}
  })
  .done(function(res) {
    if (res == 'success') {
      triggerAlert('success', 'Updated');
    }
    else {
      triggerAlert('error', 'Error Occured!');
    }
  })
  .fail(function() {
    triggerAlert('error', 'Error Occured!');
  });
}
function deleteField(elID, id){
  let count = $('.dclasspm').length;
  if (count > 1) {
    $.ajax({
      url: 'https://dp-client.com/insurance/dashboard/deleteField',
      type: 'POST',
      data: {id:id}
    })
    .done(function(res) {
      if (res == 'success') {
        $('#'+elID).slideUp();
        swal({
          title: "Item Deleted!",
          text: "The item has been deleted successfully.",
          icon: "success",
          button: false,
          timer: 2500
        });
      }
      else {
        swal({
          title: "Error Occurred!",
          text: "Unable to process the request!",
          icon: "error",
          button: false,
          timer: 2500
        });
      }
    })
    .fail(function() {
      swal({
        title: "Error Occurred!",
        text: "Unable to process the request!",
        icon: "error",
        button: false,
        timer: 2500
      });
    });
  } else {
    swal({
      title: "Error Occurred!",
      text: "You must have at least one item.",
      icon: "error",
      button: false,
      timer: 2500
    });
  }
}