$(document).ready(function() {
  var table = $('#messages-table-1').DataTable({
    "columnDefs": [
      {
        "targets": 1, // The index of the checkbox column (second column, so index is 1)
        "orderable": false // Disable sorting on this column
      },
      {
        "targets": 0, // The index of the Sr. column (first column, so index is 0)
        "visible": false // Hide the Sr. column
      }
    ],
    "initComplete": function () {
      // Add a placeholder to the search input
      $('#messages-table-1_wrapper .dt-search input').attr('placeholder', 'Search Customer Data...');
    }
  });
  var checkboxState = {};
  // Handle click on "Select all" control
  $('#select-all').on('click', function() {
    var isChecked = this.checked;
    $('input.row-checkbox').each(function() {
      $(this).prop('checked', isChecked);
      checkboxState[$(this).val()] = isChecked;
    });
    toggleDeleteButton();
  });
  // Handle click on checkboxes
  $('#messages-table-1 tbody').on('click', '.row-checkbox', function() {
    checkboxState[$(this).val()] = $(this).prop('checked');
    if ($('input.row-checkbox:checked').length === $('input.row-checkbox').length) {
      $('#select-all').prop('checked', true);
    } else {
      $('#select-all').prop('checked', false);
    }
    toggleDeleteButton();
  });
  // On each draw event, restore the state of checkboxes
  table.on('draw', function() {
    $('input.row-checkbox').each(function() {
      if (checkboxState[$(this).val()]) {
        $(this).prop('checked', true);
      }
    });
    toggleDeleteButton();
  });
  function toggleDeleteButton() {
    if ($('input.row-checkbox:checked').length > 0) {
      $('#delete-button-message').show();
    } else {
      $('#delete-button-message').hide();
    }
  }
  // Handle the delete button click event
  $('#delete-button-message').on('click', function(e) {
    e.preventDefault(); // Prevent the default form submission
    swal({
      title: "Are you sure?",
      text: "You won't be able to revert this!",
      icon: "warning",
      buttons: true,
      dangerMode: true,
    })
    .then((willDelete) => {
      if (willDelete) {
        $('#deleteMessagesForm').submit(); // Submit the form if confirmed
      }
    });
  });
});