// Load deductables
function loadDeductible(iid){
  $.ajax({
    url: 'https://dp-client.com/insurance/policy/getDeductible.php',
    type: 'POST',
    data: {iid:iid}
  })
  .done(function(res) {
    if (res == 'error') {
      swal({
        title: "Unable to fetch data!",
        text: "Please try again!",
        icon: "error",
        button: false,
        timer: 2500
      });
    }else {
      $('#deductible').html(res);
    }
  })
  .fail(function() {
    swal({
      title: "Unable to fetch data!",
      text: "Please try again!",
      icon: "error",
      button: false,
      timer: 2500
    });
  });
}
$(document).ready(function() {
  // Initialize Parsley validation
  $('#policy-form').parsley();
  $('.area-of-cover-checkbox').on('change', function() {
    var regionID = $(this).val();
    if ($(this).is(':checked')) {
      $('#loader').show(); // Show loader
      $.ajax({
        url: 'https://dp-client.com/insurance/policy/getCountriesByRegion',
        type: 'POST',
        data: { region_id: regionID },
        success: function(response) {
          var countries = JSON.parse(response);
          var html = '<div class="listing-show-country">' +
          '<div class="flex-js-b">' +
          '<p class="asia-sl">' + countries.region_name + '</p>' +
          '<div class="include-all">' +
          '<button class="pos-relative btntype-check" type="button">' +
          '<input id="Include-all-' + regionID + '" class="asButton include-all-checkbox" type="checkbox" name="">' +
          '<label for="Include-all-' + regionID + '">Include all</label>' +
          '</button>' +
          '</div>' +
          '</div>' +
          '<div class="according-country loc-ul continent-div wrap-multi-chekbox dflex">';
          $.each(countries.data, function(index, country) {
            html += '<button class="pos-relative btntype-check" type="button">' +
            '<input id="' + country.name + '-' + regionID + '" class="asButton country-checkbox" type="checkbox" name="country[]" value="' + country.name + '" data-parsley-multiple="locations" required>' +
            '<label for="' + country.name + '-' + regionID + '">' + country.name + '</label>' +
            '</button>';
          });
          html += '</div></div>';
          $('#country-list').append(html);
          $('#loader').hide(); // Hide loader
        },
        error: function() {
          $('#loader').hide(); // Hide loader in case of error
          alert('Error loading countries.');
        }
      });
    } else {
      // If unchecked, remove the related country list
      $('.listing-show-country:has(.asia-sl:contains(' + $(this).next('label').text() + '))').remove();
    }
  });
  // Handle "Include all" functionality
  $(document).on('change', '.include-all-checkbox', function() {
    $(this).closest('.listing-show-country').find('.country-checkbox').prop('checked', $(this).is(':checked')).trigger('change');
  });
});