$(document).ready(function () {
  var currentStep = 0;
  var steps = $(".step");
  var progressBarItems = $("#progressbar li");
  var $form = $('#multiStepForm');
  // Function to show the current step
  function showStep(step) {
    $(steps).removeClass("active");
    $(progressBarItems).removeClass("active");
    $(steps[step]).addClass("active");
    $(progressBarItems[step]).addClass("active");
  }
  // Show the first step initially
  showStep(currentStep);
  $(".btn-next").click(function () {
    // Validate the current step's fields
    if ($($form).parsley().validate({group: 'block-' + currentStep})) {
      if (currentStep < steps.length - 1) {
        currentStep++;
        showStep(currentStep);
      }
    }
  });
  $(".btn-prev").click(function () {
    if (currentStep > 0) {
      currentStep--;
      showStep(currentStep);
    }
  });
  // Set Parsley groups for each step
  $(steps).each(function (index) {
    $(this).find('input, select').attr('data-parsley-group', 'block-' + index);
  });
});
$(document).ready(function() {
  // Fetch and assign value
  $('.addchild').hide();
  $('.childAge').hide();
  // $('#area_of_cover').on('change', function() {
  //   var continent = $(this).val();
  //   if (continent) {
  //     $.ajax({
  //       url: 'https://dp-client.com/insurance/home/fetch_country', // Your server script
  //       type: 'POST',
  //       data: {continent: continent},
  //       dataType: 'json',
  //       success: function(response) {
  //         $('#nationality').empty(); // Clear the current options
  //         $('#nationality').append('<option value="">Choose your nationality</option>'); // Add the default option
  //         // Loop through the JSON array and append options
  //         $.each(response, function(index, country) {
  //           $('#nationality').append('<option value="'+ country.name +'">'+ country.name +'</option>');
  //         });
  //       },
  //       error: function() {
  //         swal({
  //           title: "Error Occured!",
  //           text: "An error occurred while fetching the countries. Please try again.",
  //           icon: "error",
  //           button: false,
  //           timer: 2500
  //         });
  //       }
  //     });
  //   } else {
  //     $('#nationality').empty(); // Clear the select box if no continent is selected
  //     $('#nationality').append('<option value="">Choose your nationality</option>'); // Add the default option
  //   }
  // });
  $('#fullname').on('input', function() {
    var fullName = $(this).val();
    $('#namePreview').val(fullName);
  });
  // Update residence preview based on area of cover selection
  $('#area_of_cover').on('change', function() {
    var areaOfCover = $(this).val();
    $('#residencePreview').val(areaOfCover);
  });
  // Update nationality preview based on nationality selection
  $('#nationality').on('change', function() {
    var nationality = $(this).val();
    $('#nationalityPreview').val(nationality);
  });
  // Update insurance plan preview based on selected radio button
  $('input[name="covered_person"]').on('click', function() {
    var selectedPlan = $('input[name="covered_person"]:checked').val();
    $('#insurancePlanPreview').val(selectedPlan);
    // alert(selectedPlan);
    if (selectedPlan == 'Myself') {
      $('.addchild').hide();
      $('.childAge').hide();
      $('#partnerAge').hide();
      $('#betterhalf_age').attr('required', false);
      $('#demoPartnerage').hide();
    }
    else if (selectedPlan == 'My Partner age') {
      $('.addchild').hide();
      $('.childAge').hide();
      $('#partnerAge').show();
      $('#betterhalf_age').attr('required', true);
      $('#demoPartnerage').show();
    }
    else if (selectedPlan == 'Me & My Kid(S)') {
      $('.addchild').show();
      $('.childAge').show();
      $('#partnerAge').hide();
      $('#betterhalf_age').attr('required', false);
      $('#demoPartnerage').hide();
    }
    else{
      $('.addchild').show();
      $('.childAge').show();
      $('#partnerAge').show();
      $('#betterhalf_age').attr('required', true);
      $('#demoPartnerage').show();
    }
  });
  // Update preview checkboxes based on the first set of checkboxes
  $('input[name="covered_type[]"]').on('change', function() {
    var isChecked = $(this).is(':checked');
    var checkboxId = $(this).attr('id');
    // Map the first set of checkboxes to the corresponding preview checkboxes
    switch (checkboxId) {
      case 'check1':
      $('#InpatientPreview').prop('checked', isChecked);
      break;
      case 'check2':
      $('#OutpatientPreview').prop('checked', isChecked);
      break;
      case 'check3':
      $('#DentalPreview').prop('checked', isChecked);
      break;
      case 'check4':
      $('#MaternityPreview').prop('checked', isChecked);
      break;
      case 'check5':
      $('#MaternityWitoutDentalPreview').prop('checked', isChecked);
      break;
    }
  });
  // Initialize the preview checkboxes based on the initial state of the first set of checkboxes
  $('input[name="covered_type[]"]').each(function() {
    var isChecked = $(this).is(':checked');
    var checkboxId = $(this).attr('id');
    switch (checkboxId) {
      case 'check1':
      $('#InpatientPreview').prop('checked', isChecked);
      break;
      case 'check2':
      $('#OutpatientPreview').prop('checked', isChecked);
      break;
      case 'check3':
      $('#DentalPreview').prop('checked', isChecked);
      break;
      case 'check4':
      $('#MaternityPreview').prop('checked', isChecked);
      break;
      case 'check5':
      $('#MaternityWitoutDentalPreview').prop('checked', isChecked);
      break;
    }
  });
  // Listen for changes in age input fields and update the previews
  $('#my_age').on('input', function() {
    var age = $(this).val();
    $('#myAgePreview').val(age);
  });
  $('#betterhalf_age').on('input', function() {
    var age = $(this).val();
    $('#betterhalfAgePreview').val(age);
  });
  // Function to add a new child row
  $(".addchild").on("click", addRow);
  // Function to remove a child row
  $(document).on("click", ".remove-btn", removeRow);
  // Function to update the limit message
  function updateLimitMessage() {
    var rowCount = $(".addedrow").length;
    if (rowCount >= 3) {
      $(".limit-message").removeClass("hidden");
    } else {
      $(".limit-message").addClass("hidden");
    }
  }
  // Function to add a new child row
  function addRow() {
    var rowCount = $(".addedrow").length;
    if (rowCount < 3) {
      var newRow = `
      <div class="flex-js-b flex-acenter withlf addedrow">
      <p class="color-7c">Child’s age</p>
      <p class="color-7c">
      <input type="number" required data-parsley-required="true" class="control-v1 child-age" name="child_age[]" aria-describedby="Child's Age">
      <button type="button" class="remove-btn outlineicons">
      <img src="./icons/remove.svg" width="16" height="16" alt="Remove"> Remove
      </button>
      </p>
      </div>`;
      $(".rows-container").append(newRow);
      updateChildPreview();
      updateLimitMessage();
    }
  }
  // Function to remove a child row
  function removeRow() {
    $(this).closest(".addedrow").remove();
    updateChildPreview();
    updateLimitMessage();
  }
  // Function to update child ages in the preview section
  function updateChildPreview() {
    var childAgesHtml = '';
    $(".child-age").each(function() {
      var ageValue = $(this).val();
      if (ageValue) {
        childAgesHtml += `<input type="text" class="form-control-xs" value="${ageValue}" placeholder="..." readonly disabled>`;
      }
    });
    $('.child-box').html(childAgesHtml);
  }
  // Update the child preview dynamically when a child age input changes
  $(document).on('input', '.child-age', function() {
    updateChildPreview();
  });
});